// ------------------------------------------------------------------------------
//  <auto-generated>
//     This code was generated from a template.
// 
//     Manual changes to this file will be overwritten if the code is regenerated.
//
//     Generated on 2017-03-16T13:37:53, by ESR Version 1.57.0.0 using ESR Database 
//  </auto-generated>
// ------------------------------------------------------------------------------

using System;
using System.IO;
using System.Runtime.CompilerServices;
using System.Text;
using System.Xml;
using System.Linq;
using System.Collections.Generic;
using DataContracts;
using System.Text.RegularExpressions;

namespace Ato.EN.IntegrationServices.CodeGenerationWRE
{

    public partial class WRE2017Validator
    {
        /// <summary>
        /// The max parameter name length is restricted by the SBR1 and SBR2 schemas - the lowest common denominator of SBR 1 is used as the default
        /// </summary>
        private int _maxParameterNameLength;

        /// <summary>
        /// The max parameter value length is restricted by the SBR1 and SBR2 schemas
        /// </summary>
        private int _maxParameterValueLength;

        /// <summary>
        /// The SBR1 and ebms3 schemas do not allow parameter names or values to be the empty string
        /// </summary>
        private string _emptyParameterValue;

        /// <summary>
        /// Initializes a new instance of the <see cref="WRE2017Validator" /> class.
        /// </summary>
        /// <param name="maxParameterNameLength">Maximum length of the parameter name.</param>
        /// <param name="maxParameterValueLength">Maximum length of the parameter value.</param>
        /// <param name="emptyParameterValue">This value will be used in place of any parameter values that result in a null or empty value.</param>
        public WRE2017Validator(int maxParameterNameLength = 20, int maxParameterValueLength = 4096, string emptyParameterValue = "EMPTY")
        {
            _maxParameterNameLength = maxParameterNameLength;
            _maxParameterValueLength = maxParameterValueLength;
            _emptyParameterValue = emptyParameterValue;
        }

        #region Functions
        private static IEnumerable<string> Union(IEnumerable<string> list1, IEnumerable<string> list2)
        {
            IEnumerable<string> response;

            if (list1 == null && list2 == null)
            {
                response = null;
            }
            else if (list1 == null)
            {
                response = list2.Distinct();
            }
            else if (list2 == null)
            {
                response = list1.Distinct();
            }
            else
            {
                response = list1.Union(list2);
            }

            return response;
        }

        private static bool IsMatch(int? field, string expression, RegexOptions options = RegexOptions.None)
        {
            if (field == null)
                return false;
            else
                return Regex.IsMatch(Convert.ToString(field.Value), expression, options);
        }

        private static bool IsMatch(string field, string expression, RegexOptions options = RegexOptions.None)
        {
            if (field == null)
                return false;
            else
                return Regex.IsMatch(field, expression, options);
        }

        // This is just context and tuple counts where they are integer values - easier that changing the parsing logic to just return the value
        private static int Count(int count)
        {
            return count;
        }


        private static int Count<T>(IEnumerable<T> values)
        {
            return values == null ? 0 : values.Where(f => f != null).Count();
        }


        private static int Count<T>(ICollection<T> values)
        {
            return values == null ? 0 : values.Where(f => f != null).Count();
        }


        private static bool exists(bool value)
        {
            return value;
        }

        private static string GetValueOrEmpty(bool? val)
        {
            return (val.HasValue) ? val.ToString() : string.Empty;
        }

        private static string GetValueOrEmpty(DateTime? val)
        {
            return (val.HasValue) ? val.ToString() : string.Empty;
        }

         /// <summary>
         /// Get string value between [first] a and [last] b.
         /// </summary>
        public static string Between(string value, string a, string b)
        {
            int posA = value.IndexOf(a);
            int posB = value.LastIndexOf(b);
            if (posA == -1)
            {
                return "";
            }
            if (posB == -1)
            {
                return "";
            }
            int adjustedPosA = posA + a.Length;
            if (adjustedPosA >= posB)
            {
                return "";
            }
            return value.Substring(adjustedPosA, posB - adjustedPosA);
        }

         /// <summary>
         /// Get string value after [first] a.
         /// </summary>
        public static string Before(string value, string a)
        {
            int posA = value.IndexOf(a);
            if (posA == -1)
            {
                return "";
            }
            return value.Substring(0, posA);
        }

         /// <summary>
         /// Get string value after [last] a.
         /// </summary>
        public static string After(string value, string a)
        {
            int posA = value.LastIndexOf(a);
            if (posA == -1)
            {
                return "";
            }
            int adjustedPosA = posA + a.Length;
            if (adjustedPosA >= value.Length)
            {
                return "";
            }
            return value.Substring(adjustedPosA);
        }

        private static int Length(object field)
        {
            if (field == null)
            return 0;
            else
            return field.ToString().Trim().Length;
        }

        private static bool NotSameValues(IEnumerable<object> nodes)
        {
            if (nodes == null)
                return false;

            object[] nodesArray = nodes.Cast<object>().ToArray();
            return NotSameValues(nodesArray);
        }

        private static bool NotSameValues(params object[] nodes)
        {
            if (nodes == null)
                return false;

            return ((from x in nodes select x).Distinct().Count() == nodes.Count());
        }

        private static bool HasDuplicateValues(IEnumerable<object> nodes)
        {
            if (nodes == null)
                return false;

            object[] nodesArray = nodes.Cast<object>().ToArray();
            return HasDuplicateValues(nodesArray);
        }

        private static bool HasDuplicateValues(params object[] nodes)
        {
            if (nodes == null)
                return false;

            return !((from x in nodes select x).Distinct().Count() == nodes.Count());
        }

        private int DuplicateValueIndex(IEnumerable<object> values)
        {
            int response = 0;
            var hashset = new HashSet<object>();
            foreach (var value in values)
            {
                if (!hashset.Add(value))
                {
                    return response;
                }
                response++;
            }
            return response;
        }

        private int DuplicateValueIndex<T>(IEnumerable<T?> values) where T : struct
        {
            int response = 0;
            var hashset = new HashSet<T?>();
            foreach (var value in values)
            {
                if (!hashset.Add(value))
                {
                    return response;
                }
                response++;
            }
            return response;
        }

        private static bool IsDate(object value)
        {
            DateTime dateValue;
            return (value != null && DateTime.TryParse(value.ToString(), out dateValue));
        }

        public DateTime AsDate(string dateAsString)
        {
            DateTime response = DateTime.MinValue;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date;
            }

            return response;
        }

        public DateTime? ConvertToDate(int day, int month, int year)
        {
            return ConvertToDate(day == 0 ? null : day.ToString(), month == 0 ? null : month.ToString(), year == 0 ? null : year.ToString());
        }

        public DateTime? ConvertToDate(string day, string month, string year)
        {
            DateTime? response;
            DateTime result;

            if (year == null || month == null || day == null)
            {
                return null;
            }
            string dateAsString = year + "-" + After(month, "--") + "-" + After(day, "---");
            if (DateTime.TryParse(dateAsString, out result))
            {
                response = result;
            }
            else
            {
                response = null;
            }
            return response;
        }


        public DateTime? ConvertToDate(string day, string month, int year)
        {
            DateTime? response;
            DateTime result;

            if (year == 0 || month == null || day == null)
            {
                return null;
            }
            string dateAsString = year.ToString() + "-" + After(month, "--") + "-" + After(day, "---");
            if (DateTime.TryParse(dateAsString, out result))
            {
                response = result;
            }
            else
            {
                response = null;
            }
            return response;
        }


        private static int Day(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Day;
            }

            return response;
        }


        private static int Day(DateTime? date)
        {
            if (date == null)
                return 0;
            else
                return date.Value.Day;

        }


        private static string Month(string dateAsString)
        {
            string response = null;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.ToString("MMMM");
            }
            else
            {
                return "NotAMonth";
            }

            return response;
        }

        private static string Month(DateTime? date)
        {
            if (date == null)
                return "NotAMonth";
            else
                return date.Value.ToString("MMMM");
        }


        private static int MonthAsInt(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Month;
            }

            return response;
        }

        private static int MonthAsInt(DateTime? date)
        {
            if (date == null)
            {
                return 0;
            }
            return date.Value.Month;
        }


        private static int Year(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
            {
                response = date.Year;
            }

            return response;
        }

        private static int Year(DateTime? date)
        {
            if (date == null)
                return 0;
            else
                return date.Value.Year;
        }


        private static int CurrentFinancialYear()
        {
            return DateToFinancialYear(DateTime.Now, 7);
        }

        private static int FinancialYear(string dateAsString)
        {
            return DateToFinancialYear(dateAsString, 7);
        }

        private static int FinancialYear(DateTime? date)
        {
            return DateToFinancialYear(date, 7);
        }

        private static int DateToFinancialYear(string dateAsString, int startingMonth)
        {
            int response = 0;
            DateTime date;
            if (DateTime.TryParse(dateAsString, out date))
            {
                response = DateToFinancialYear(date, startingMonth);
            }

            return response;
        }
        private static int DateToFinancialYear(DateTime? date, int startingMonth)
        {
            int response;
            if (date == null)
            {
                response = 0;
            }
            else
            {
                int year = date.Value.Year;
                int month = date.Value.Month;

                if (startingMonth > month)
                    response = year;
                else
                    response = year + 1;
            }
            return response;
        }


        private static int FBTYear(string dateAsString)
        {
            int response = 0;
            DateTime date;

            if (DateTime.TryParse(dateAsString, out date))
                response = FBTYear(date);
            return response;
        }

        private static int FBTYear(DateTime? date)
        {
            if (date == null)
            {
                return 0;
            }
            else
            {
                if (date.Value.Month > 3)
                    return date.Value.Year + 1;
                else
                    return date.Value.Year;
            }
        }


        private static bool IsNumeric(object value)
        {
            decimal numbervalue;
            return (value != null && decimal.TryParse(value.ToString(), out numbervalue));
        }

        private static bool NotMonetary(decimal? field, string sign, int digits, int decimals)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;
                string decimalExpression;
                int digitsToUse = digits - decimals;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                if (decimals > 0)
                    decimalExpression = @"(\.\d{1," + decimals + "})?$";
                else
                    decimalExpression = @"$";

                return !(Regex.IsMatch(field.Value.ToString("0.#########################"), signExpression + @"\d{1," + digitsToUse + "}" + decimalExpression));
            }
        }

        private static bool NotNumeric(decimal? field, string sign, int digits, int decimals)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;
                string decimalExpression;
                int digitsToUse = digits - decimals;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                if (decimals > 0)
                    decimalExpression = @"(\.\d{1," + decimals + "})?$";
                else
                    decimalExpression = @"$";

                return !(Regex.IsMatch(field.Value.ToString("0.#########################"), signExpression + @"\d{1," + digitsToUse + "}" + decimalExpression));
            }
        }

        private static bool NotNumeric(int? field, string sign, int digits, int decimals = 0)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                return !(Regex.IsMatch(field.Value.ToString(), signExpression + @"\d{1," + digits + "}$"));
            }
        }

        private static bool NotNumeric(long? field, string sign, int digits, int decimals = 0)
        {
            if (field == null)
            {
                return false;
            }
            else
            {
                string signExpression;

                if (sign == "U")
                    signExpression = "^";
                else
                    signExpression = "^-?";

                return !(Regex.IsMatch(field.Value.ToString(), signExpression + @"\d{1," + digits + "}$"));
            }
        }


        private static bool OutsideRange(decimal field, decimal expression, int range)
        {
            bool response;

            response = (field < (expression - range)) || (field > (expression + range));

            return response;
        }


        private static bool FailsUSIAlgorithm(string usi, string abn)
        {
            bool response;
            if (usi == null || abn == null)
            {
                response = false;
            }
            else
            {
                usi = usi.Trim();
                abn = abn.Trim();
                if (usi.Length < 13 || abn.Length < 11)
                {
                    response = false;
                }
                else
                {
                    int numeric;
                    if (usi.Substring(0, 11) == abn && int.TryParse(usi.Substring(11, 2), out numeric))
                        response = false;
                    else if (Regex.IsMatch(usi, @"^[a-zA-Z]{3}\d{4}[a-zA-Z]{2}"))
                        response = false;
                    else
                        response = true;
                }
            }
            return response;
        }


        private static bool FailsTANAlgorithm(string tan)
        {
            bool response;
            decimal decimalTan;

            if (tan == null)
                return false;

            tan = tan.Trim();

            if (!decimal.TryParse(tan, out decimalTan))
                return true;

            if (tan.Length != 8)
                return true;

            decimal tanSum =
                7 * int.Parse(tan.Substring(0, 1)) +
                9 * int.Parse(tan.Substring(1, 1)) +
                8 * int.Parse(tan.Substring(2, 1)) +
                4 * int.Parse(tan.Substring(3, 1)) +
                6 * int.Parse(tan.Substring(4, 1)) +
                3 * int.Parse(tan.Substring(5, 1)) +
                5 * int.Parse(tan.Substring(6, 1)) +
                1 * int.Parse(tan.Substring(7, 1));

            if ((tanSum % 11) == 0)
                response = false;
            else
                response = true;

            return response;
        }


        private static bool FailsABNAlgorithm(string abn)
        {
            bool response;
            decimal decimalAbn;

            if (abn == null)
                return false;

            abn = abn.Trim();

            if (!decimal.TryParse(abn, out decimalAbn))
                return true;

            if (abn.Length != 11)
                return true;

            decimal abnSum =
                10 * (int.Parse(abn.Substring(0, 1)) - 1) +
                1 * int.Parse(abn.Substring(1, 1)) +
                3 * int.Parse(abn.Substring(2, 1)) +
                5 * int.Parse(abn.Substring(3, 1)) +
                7 * int.Parse(abn.Substring(4, 1)) +
                9 * int.Parse(abn.Substring(5, 1)) +
                11 * int.Parse(abn.Substring(6, 1)) +
                13 * int.Parse(abn.Substring(7, 1)) +
                15 * int.Parse(abn.Substring(8, 1)) +
                17 * int.Parse(abn.Substring(9, 1)) +
                19 * int.Parse(abn.Substring(10, 1));

            if ((abnSum % 89) == 0)
                response = false;
            else
                response = true;

            return response;
        }
        private static bool FailsACNAlgorithm(string acn)
        {
            bool response;
            decimal decimalAbn;
            if (acn == null)
                return false;

            acn = acn.Trim();

            if (!decimal.TryParse(acn, out decimalAbn))
                return true;

            if (acn.Length != 9)
                return true;

            decimal abnSum =
                8 * int.Parse(acn.Substring(0, 1)) +
                7 * int.Parse(acn.Substring(1, 1)) +
                6 * int.Parse(acn.Substring(2, 1)) +
                5 * int.Parse(acn.Substring(3, 1)) +
                4 * int.Parse(acn.Substring(4, 1)) +
                3 * int.Parse(acn.Substring(5, 1)) +
                2 * int.Parse(acn.Substring(6, 1)) +
                1 * int.Parse(acn.Substring(7, 1));

            decimal checkDigit = int.Parse(acn.Substring(8, 1));
            decimal acnRemainder = abnSum % 10;

            if (((10 - acnRemainder) % 10) == checkDigit)
                response = false;
            else
                response = true;

            return response;
        }


        private static bool FailsTFNAlgorithm(string tfn)
        {
            bool response;
            decimal decimalTfn;

            if (tfn == null)
                return false;

            tfn = tfn.Trim();
            tfn = Regex.Replace(tfn, "^0+", "");

            if (!decimal.TryParse(tfn, out decimalTfn))
                return true;

            if (tfn.Length < 8)
                return true;


            decimal tfn1To7Sum =
                1 * int.Parse(tfn.Substring(0, 1)) +
                4 * int.Parse(tfn.Substring(1, 1)) +
                3 * int.Parse(tfn.Substring(2, 1)) +
                7 * int.Parse(tfn.Substring(3, 1)) +
                5 * int.Parse(tfn.Substring(4, 1)) +
                8 * int.Parse(tfn.Substring(5, 1)) +
                6 * int.Parse(tfn.Substring(6, 1));

            decimal tfn8 = 9 * int.Parse(tfn.Substring(7, 1));

            if (tfn.Length == 8)
            {
                decimal tFNLg8WSum9 = 10 * int.Parse(tfn.Substring(7, 1));
                decimal tFNLg8WSum = tfn1To7Sum + tFNLg8WSum9;

                if ((tFNLg8WSum % 11) == 0)
                    response = false;
                else
                    response = true;
            }
            else if (tfn.Length == 9)
            {
                decimal tfn9 = 10 * int.Parse(tfn.Substring(8, 1));
                decimal tFNLg9WSum = tfn1To7Sum + tfn8 + tfn9;

                if ((tFNLg9WSum % 11) == 0)
                    response = false;
                else
                    response = true;
            }
            else
            {
                response = true;
            }

            return response;
        }


        private static decimal ConditionalValue(bool expression, decimal? trueVal, decimal? falseVal)
        {
             return expression ? trueVal.GetValueOrDefault() : falseVal.GetValueOrDefault();
        }

        private static decimal AsNumeric(string value)
        {
             decimal numberValue;
             decimal.TryParse(value, out numberValue);
             return numberValue;
        }

        private static bool RegexMatch(int? field, string expression, string flags="")
        {
            return IsMatch(field, expression, GetRegexOption(flags));
        }

        private static bool RegexMatch(string field, string expression, string flags="")
        {
            return IsMatch(field, expression, GetRegexOption(flags));
        }

        private static RegexOptions GetRegexOption(string flags)
        {
            RegexOptions options = RegexOptions.None;

            char[] characters = flags.ToCharArray();

            foreach (char character in characters)
            {
                switch (character)
                {
                    case 'i':                        
                        options = options | RegexOptions.IgnoreCase;                       
                        break;
                    case 'm':                        
                        options = options | RegexOptions.Multiline;                       
                        break;
                    case 's':                        
                            options = options | RegexOptions.Singleline;                       
                        break;
                    case 'n':                        
                            options = options | RegexOptions.ExplicitCapture;                       
                        break;
                    case 'x':                       
                            options = options | RegexOptions.IgnorePatternWhitespace;                       
                        break;
                }
            }

            return options;
        }

        /// <summary>
        /// Returns an occurrence index as [occurrenceIndex] of occurrenceIndex > 0, otherwise the empty string
        /// </summary>
        /// <param name="occurrenceIndex">Index of the occurrence.</param>
        /// <returns>Occurrence in XPath [#] format</returns>
        public string OccurrenceIndex(int occurrenceIndex)
        {
            return occurrenceIndex > 0 ? "[" + occurrenceIndex + "]" : "";
        }

        #endregion // Functions

        public WRE2017 ConsumedReport { get; private set; }

        public List<ProcessMessageDocument> ValidateReport(WRE2017 report)
        {

            List<ProcessMessageDocument> response = new List<ProcessMessageDocument>();
            ProcessMessageDocument processMessage;
            ProcessMessageParameter parameter;
            bool assertion;

            this.ConsumedReport = report;

            // ------------------------------------------------------------------------------
            // Validations are now done in code.
            // This version supports full validation of a report - for those rules that have successfully parsed and could be generated.
            // Generated Validations include:
            //   - Validation logic in C#.
            //   - Production of errors in EBMS, SBR and SWS format.
            // 
            // The generation at this stage does not support the following - and has to be completed manually (later versions of the generation will do this for you)
            //   - Business Rules that did not parse.  The ESR team will help support you where this happens as an effort is being made to rectify these
            //   - You will get TODO tasks for those that the parser could not cope with
            // ------------------------------------------------------------------------------

    
            #region VR.ATO.GEN.000209
    
            /*  VR.ATO.GEN.000209
            Invalid context. The number of Reporting party contexts must equal 1
    
            Legacy Rule Format:
            IF COUNT(RP) <> 1
            RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            Count(^Context) <> 1
    
            Data Elements:
    
            ^Context = RP
            */
            assertion = (Count(report.RPCount) != 1);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.430296", Severity = ProcessMessageSeverity.Error,
                    Description = @"Invalid context. The number of Reporting party contexts must equal 1",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPLastOccurrenceIndex),
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.GEN.000209"} },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.000209
    
            #region VR.ATO.GEN.500075
    
            /*  VR.ATO.GEN.500075
            Entity identifier scheme for ReportingParty must be "http://www.ato.gov.au/tfn"
    
            Legacy Rule Format:
            IF (RP:entity.identifier.scheme <> "http://www.ato.gov.au/tfn")
                RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^IdentifierScheme <> 'http://www.ato.gov.au/tfn'
    
            Data Elements:
    
            ^IdentifierScheme = RP
            */
            assertion = ((report.RPExists == true) && (report.RPIdentifierScheme != @"http://www.ato.gov.au/tfn"));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.GEN.438029", Severity = ProcessMessageSeverity.Error,
                    Description = @"Entity identifier scheme for ReportingParty must be ""http://www.ato.gov.au/tfn""",
                    Location = "/xbrli:xbrl/xbrli:context" + OccurrenceIndex(report.RPOccurrenceIndex) + "/xbrli:entity/xbrli:identifier/@scheme",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.GEN.500075"} },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.GEN.500075
    
            #region VR.ATO.WRE.000020
    
            /*  VR.ATO.WRE.000020
            Self education expenses - s82A reduction amount has a maximum field length of 11
    
            Legacy Rule Format:
            IF ([wre46] <> MONETARY(U,11,0))
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (NotMonetary(^WRE46, 'U', 11, 0))
    
            Data Elements:
    
            RP:^WRE46 = tns:IncomeTax.Deduction.EducationReduction.Amount
            */
            assertion = NotMonetary(report.WRE46, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.WRE.000020", Severity = ProcessMessageSeverity.Error,
                    Description = @"Self education expenses - s82A reduction amount is not in a valid monetary format",
                    LongDescription = @"Self education expenses - s82A reduction amount must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.EducationReduction.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000020"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "WRE46", Value = report.WRE46.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.WRE.000020
    
            #region VR.ATO.WRE.000021
    
            /*  VR.ATO.WRE.000021
            Self education expenses - Net deduction has a maximum field length of 11
    
            Legacy Rule Format:
            IF ([wre47] <> MONETARY(U,11,0))
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (NotMonetary(^WRE47, 'U', 11, 0))
    
            Data Elements:
    
            RP:^WRE47 = tns:IncomeTax.Deduction.EducationNet.Amount
            */
            assertion = NotMonetary(report.WRE47, @"U", 11, 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.WRE.000021", Severity = ProcessMessageSeverity.Error,
                    Description = @"Self education expenses - Net deduction is not in a valid monetary format",
                    LongDescription = @"Self education expenses - Net deduction must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.EducationNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000021"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "WRE47", Value = report.WRE47.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.WRE.000021
    
            #region VR.ATO.WRE.000026
    
            /*  VR.ATO.WRE.000026
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF ([wre12] <> NULLORBLANK) AND (ANY CHARACTER OF [wre12] <> SET("a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotCharacterInSet(^WRE12, '"a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "')
    
            Data Elements:
    
            RP:^WRE12 = tns:IncomeTax.Deduction.CarReason.Description
            */
            assertion = !string.IsNullOrWhiteSpace(report.WRE12) && !(IsMatch(report.WRE12, @"^[a-zA-Z0-9!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ]*$",RegexOptions.IgnoreCase));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.WRE.000026", Severity = ProcessMessageSeverity.Error,
                    Description = @"Car expenses - Explanation and justification for work purposes contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.CarReason.Description",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000026"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "WRE12", Value = report.WRE12 });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.WRE.000026
    
            #region VR.ATO.WRE.000029
    
            /*  VR.ATO.WRE.000029
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF ([wre24] <> NULLORBLANK) AND (ANY CHARACTER OF [wre24] <> SET("a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotCharacterInSet(^WRE24, '"a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "')
    
            Data Elements:
    
            RP:^WRE24 = tns:IncomeTax.Deduction.TravelReason.Description
            */
            assertion = !string.IsNullOrWhiteSpace(report.WRE24) && !(IsMatch(report.WRE24, @"^[a-zA-Z0-9!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ]*$", RegexOptions.IgnoreCase));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.WRE.000029", Severity = ProcessMessageSeverity.Error,
                    Description = @"Other travel expenses - Explain how these expenses relate to your work contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.TravelReason.Description",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000029"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "WRE24", Value = report.WRE24 });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.WRE.000029
    
            #region VR.ATO.WRE.000032
    
            /*  VR.ATO.WRE.000032
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF ([wre31] <> NULLORBLANK) AND (ANY CHARACTER OF [wre31] <> SET("a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotCharacterInSet(^WRE31, '"a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "')
    
            Data Elements:
    
            RP:^WRE31 = tns:IncomeTax.Deduction.ClothingReason.Description
            */
            assertion = !string.IsNullOrWhiteSpace(report.WRE31) && !(IsMatch(report.WRE31, @"^[a-zA-Z0-9!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ]*$", RegexOptions.IgnoreCase));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.WRE.000032", Severity = ProcessMessageSeverity.Error,
                    Description = @"'Uniform, protective or occupation specific clothing and laundry expenses...' contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.ClothingReason.Description",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000032"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "WRE31", Value = report.WRE31 });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.WRE.000032
    
            #region VR.ATO.WRE.000035
    
            /*  VR.ATO.WRE.000035
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF ([wre38] <> NULLORBLANK) AND (ANY CHARACTER OF [wre38] <> SET("a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotCharacterInSet(^WRE38, '"a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "')
    
            Data Elements:
    
            RP:^WRE38 = tns:IncomeTax.Deduction.EducationReason.Description
            */
            assertion = !string.IsNullOrWhiteSpace(report.WRE38) && !(IsMatch(report.WRE38, @"^[a-zA-Z0-9!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ]*$", RegexOptions.IgnoreCase));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.WRE.000035", Severity = ProcessMessageSeverity.Error,
                    Description = @"Self education expenses - Explain how expenses relate to current work activities contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.EducationReason.Description",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000035"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "WRE38", Value = report.WRE38 });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.WRE.000035
    
            #region VR.ATO.WRE.000040
    
            /*  VR.ATO.WRE.000040
            A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
            Legacy Rule Format:
            IF ([wre49] <> NULLORBLANK) AND (ANY CHARACTER OF [wre49] <> SET("a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            NotCharacterInSet(^WRE49, '"a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "')
    
            Data Elements:
    
            RP:^WRE49 = tns:IncomeTax.Deduction.WorkRelatedReasonOther.Description
            */
            assertion = !string.IsNullOrWhiteSpace(report.WRE49) && !(IsMatch(report.WRE49, @"^[a-zA-Z0-9!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ]*$", RegexOptions.IgnoreCase));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.WRE.000040", Severity = ProcessMessageSeverity.Error,
                    Description = @"Other work expenses - Explanation and justification for work purposes of each expense contains invalid text",
                    LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.WorkRelatedReasonOther.Description",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000040"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "WRE49", Value = report.WRE49 });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.WRE.000040
    
            #region VR.ATO.WRE.000066
    
            /*  VR.ATO.WRE.000066
            Self education expenses - s82A reduction amount maximum is $250
    
            Legacy Rule Format:
            IF ([wre46] > 250)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            ^WRE46 > 250
    
            Data Elements:
    
            RP:^WRE46 = tns:IncomeTax.Deduction.EducationReduction.Amount
            */
            assertion = (report.WRE46.GetValueOrDefault() > 250);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.WRE.000066", Severity = ProcessMessageSeverity.Error,
                    Description = @"The Self education expenses - s82A reduction amounts must not exceed $250",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.EducationReduction.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000066"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "WRE46", Value = report.WRE46.GetValueOrDefault().ToString() });
    
                response.Add(processMessage);
            }
            #endregion // VR.ATO.WRE.000066
    
            #region VR.ATO.WRE.000067
    
            /*  VR.ATO.WRE.000067
            Self education expenses - Net deduction is not equal to Self education expenses - Gross amount less Self education expenses - s82A reduction amount
    
            Legacy Rule Format:
            IF ([wre47] <> NULL AND [wre47] <> (SUM([wre45]) - [wre46])) OR ([wre47] = NULL AND 
            (SUM([wre45]) - [wre46]) <> 0)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            (^WRE47 <> NULL AND ^WRE47 <> (Sum(^WRE45) - ^WRE46)) OR (^WRE47 = NULL AND (Sum(^WRE45) - ^WRE46) <> 0)
    
            Data Elements:
    
            RP:^WRE47 = tns:IncomeTax.Deduction.EducationNet.Amount
    
            RP.{EduSeqNum}:^WRE45 = tns:IncomeTax.Deduction.Education.Amount
    
            RP:^WRE46 = tns:IncomeTax.Deduction.EducationReduction.Amount
            */
            assertion = (report.WRE47 != null && report.WRE47.GetValueOrDefault() != (report.RPEduSeqNumContextCollection == null ? 0 : report.RPEduSeqNumContextCollection.Sum(f => f.WRE45.GetValueOrDefault())) - report.WRE46.GetValueOrDefault() || report.WRE47 == null && (report.RPEduSeqNumContextCollection == null ? 0 : report.RPEduSeqNumContextCollection.Sum(f => f.WRE45.GetValueOrDefault())) - report.WRE46.GetValueOrDefault() != 0);
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.WRE.000067", Severity = ProcessMessageSeverity.Error,
                    Description = @"Self education expenses - Net deduction is invalid",
                    LongDescription = @"The 'Self education expenses - Net deduction' amount must equal the sum of 'Self education expenses - Gross amount' less 'Self education expenses - s82A reduction amount'",
                    Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.EducationNet.Amount",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000067"} },
                };
                processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "WRE47", Value = report.WRE47.GetValueOrDefault().ToString() });
                
                if (report.RPEduSeqNumContextCollection != null)
                {
                    decimal? wre45total = 0;

                    foreach (WRE2017.RPEduSeqNumContext context in report.RPEduSeqNumContextCollection)
                    {
                        wre45total += context.WRE45.GetValueOrDefault();
                    }
                    
                    processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "WRE45", Value = wre45total.ToString() });

                    processMessage.Parameters.Add(new ProcessMessageParameter
                    { Name = "WRE46", Value = report.WRE46.GetValueOrDefault().ToString() });

                    response.Add(processMessage);
                }
            }
            #endregion // VR.ATO.WRE.000067
    
            #region VR.ATO.WRE.000072
    
            /*  VR.ATO.WRE.000072
            The Sequence Container within the Car Sequence Dimension context instance must not be duplicated
    
            Legacy Rule Format:
            IF ([wre60] = ANY OTHER OCCURRENCE OF [wre60])
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            HasDuplicateValues(^WRE60)
    
            Data Elements:
    
            RP.{CarSeqNum}:^WRE60 = tns:Report.ItemOrder.Number
            */
            assertion = HasDuplicateValues(report.RPCarSeqNumContextCollection == null ? null : report.RPCarSeqNumContextCollection.Select(f => f.WRE60));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.WRE.000072", Severity = ProcessMessageSeverity.Error,
                    Description = @"Reporting Party Car Sequence Container must not be duplicated",
                    LongDescription = @"The Sequence Container within the Car Sequence Dimension context instance must not be duplicated",
                    Location = "/xbrli:xbrl/xbrli:context[@id='" + report.RPCarSeqNumContextCollection[DuplicateValueIndex(report.RPCarSeqNumContextCollection.Select(f => f.WRE60))].Id + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000072"} },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.WRE.000072
    
            #region VR.ATO.WRE.000074
    
            /*  VR.ATO.WRE.000074
            The Sequence Container within the Travel Sequence Dimension context instance must not be duplicated
    
            Legacy Rule Format:
            IF ([wre61] = ANY OTHER OCCURRENCE OF [wre61])
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            HasDuplicateValues(^WRE61)
    
            Data Elements:
    
            RP.{TrvlSeqNum}:^WRE61 = tns:Report.ItemOrder.Number
            */
            assertion = HasDuplicateValues(report.RPTrvlSeqNumContextCollection == null ? null : report.RPTrvlSeqNumContextCollection.Select(f => f.WRE61));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.WRE.000074", Severity = ProcessMessageSeverity.Error,
                    Description = @"Reporting Party Travel Sequence Container must not be duplicated",
                    LongDescription = @"The Sequence Container within the Travel Sequence Dimension context instance must not be duplicated",
                    Location = "/xbrli:xbrl/xbrli:context[@id='" + report.RPTrvlSeqNumContextCollection[DuplicateValueIndex(report.RPTrvlSeqNumContextCollection.Select(f => f.WRE61))].Id + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000074"} },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.WRE.000074
    
            #region VR.ATO.WRE.000076
    
            /*  VR.ATO.WRE.000076
            The Sequence Container within the Clothing Sequence Dimension context instance must not be duplicated
    
            Legacy Rule Format:
            IF ([wre62] = ANY OTHER OCCURRENCE OF [wre62])
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            HasDuplicateValues(^WRE62)
    
            Data Elements:
    
            RP.{ClthngSeqNum}:^WRE62 = tns:Report.ItemOrder.Number
            */
            assertion = HasDuplicateValues(report.RPClthngSeqNumContextCollection == null ? null : report.RPClthngSeqNumContextCollection.Select(f => f.WRE62));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.WRE.000076", Severity = ProcessMessageSeverity.Error,
                    Description = @"Reporting Party Clothing Sequence Container must not be duplicated",
                    LongDescription = @"The Sequence Container within the Clothing Sequence Dimension context instance must not be duplicated",
                    Location = "/xbrli:xbrl/xbrli:context[@id='" + report.RPClthngSeqNumContextCollection[DuplicateValueIndex(report.RPClthngSeqNumContextCollection.Select(f => f.WRE62))].Id + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000076"} },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.WRE.000076
    
            #region VR.ATO.WRE.000078
    
            /*  VR.ATO.WRE.000078
            The Sequence Container within the Education Sequence Dimension context instance must not be duplicated
    
            Legacy Rule Format:
            IF ([wre63] = ANY OTHER OCCURRENCE OF [wre63])
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            HasDuplicateValues(^WRE63)
    
            Data Elements:
    
            RP.{EduSeqNum}:^WRE63 = tns:Report.ItemOrder.Number
            */
            assertion = HasDuplicateValues(report.RPEduSeqNumContextCollection == null ? null : report.RPEduSeqNumContextCollection.Select(f => f.WRE63));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.WRE.000078", Severity = ProcessMessageSeverity.Error,
                    Description = @"Reporting Party Education Sequence Container must not be duplicated",
                    LongDescription = @"The Sequence Container within the Education Sequence Dimension context instance must not be duplicated",
                    Location = "/xbrli:xbrl/xbrli:context[@id='" + report.RPEduSeqNumContextCollection[DuplicateValueIndex(report.RPEduSeqNumContextCollection.Select(f => f.WRE63))].Id + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000078"} },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.WRE.000078
    
            #region VR.ATO.WRE.000080
    
            /*  VR.ATO.WRE.000080
            The Sequence Container within the Other Work Related Sequence Dimension context instance must not be duplicated
    
            Legacy Rule Format:
            IF ([wre64] = ANY OTHER OCCURRENCE OF [wre64])
                 RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            HasDuplicateValues(^WRE64)
    
            Data Elements:
    
            RP.{OTHWRSeqNum}:^WRE64 = tns:Report.ItemOrder.Number
            */
            assertion = HasDuplicateValues(report.RPOTHWRSeqNumContextCollection == null ? null : report.RPOTHWRSeqNumContextCollection.Select(f => f.WRE64));
            if (assertion)
            {
                processMessage = new ProcessMessageDocument()
                {
                    Code = "CMN.ATO.WRE.000080", Severity = ProcessMessageSeverity.Error,
                    Description = @"Reporting Party Other Work Related Sequence Container must not be duplicated",
                    LongDescription = @"The Sequence Container within the Other Work Related Sequence Dimension context instance must not be duplicated",
                    Location = "/xbrli:xbrl/xbrli:context[@id='" + report.RPOTHWRSeqNumContextCollection[DuplicateValueIndex(report.RPOTHWRSeqNumContextCollection.Select(f => f.WRE64))].Id + "']",
                    Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000080"} },
                };
                response.Add(processMessage);
            }
            #endregion // VR.ATO.WRE.000080
    
            #region VR.ATO.GEN.001023
    
            /*  VR.ATO.GEN.001023
            TFN in entity identifier of context does not match the TFN provided for the Reporting Party
    
            Legacy Rule Format:
            IF (RP:entity.identifier.TFN <> ANY OCCURRENCE OF entity.identifier.TFN)
               RETURN VALIDATION MESSAGE
            ENDIF

            Technical Business Rule Format:
            AnyOccurrence(^TFN2, ^TFN2 <> ^TFN)
    
            Data Elements:
    
            ^TFN = RP
    
            ^TFN2 = Other TFNs
            */

            response = ValidateGEN001023(response, report);

            #endregion // VR.ATO.GEN.001023

            #region Repeating RPCarSeqNumContext
            if (report.RPCarSeqNumContextCollection != null)
            {
                int itemIndexContext2 = 0;
                foreach (WRE2017.RPCarSeqNumContext rpCarSeqNumContext in report.RPCarSeqNumContextCollection)
                {
                    itemIndexContext2++;
            
                    #region VR.ATO.WRE.000001
            
                    /*  VR.ATO.WRE.000001
                    Car expenses - Description of car (make, model) has a maximum length of 20
    
                    Legacy Rule Format:
                    IF (LENGTH([wre13])) > 20
                         RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (Length(^WRE13)) > 20
            
                    Data Elements:
            
                    RP.{CarSeqNum}:^WRE13 = tns:Assets.CarMakeModel.Description
                    */
                    assertion = (Length(rpCarSeqNumContext.WRE13) > 20);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000001", Severity = ProcessMessageSeverity.Error,
                            Description = @"Car expenses - Description of car (make, model) must not exceed 20 characters",
                            LongDescription = @"For Car expenses - Description of car (make, model), the maximum allowable characters for this form is 20",
                            Location = "/xbrli:xbrl/tns:Assets.CarMakeModel.Description[@contextRef='" + rpCarSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000001"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE13", Value = rpCarSeqNumContext.WRE13 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000001
            
                    #region VR.ATO.WRE.000002
            
                    /*  VR.ATO.WRE.000002
                    Car expenses - Log book method - Business % shown in log book has a maximum length of 3
    
                    Legacy Rule Format:
                    IF LENGTH([wre16]) > 3
                         RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    Length(^WRE16) > 3
            
                    Data Elements:
            
                    RP.{CarSeqNum}:^WRE16 = tns:IncomeTax.Deduction.CarLogBookMethodBusinessUseRecorded.Percent
                    */
                    assertion = (Length(rpCarSeqNumContext.WRE16.GetValueOrDefault()) > 3);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000002", Severity = ProcessMessageSeverity.Error,
                            Description = @"Car expenses - Log book method - Business % shown in log book must not exceed 3 characters",
                            LongDescription = @"For Car expenses - Log book method - Business % shown in log book, the maximum allowable characters for this form is 3",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.CarLogBookMethodBusinessUseRecorded.Percent[@contextRef='" + rpCarSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000002"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE16", Value = rpCarSeqNumContext.WRE16.GetValueOrDefault().ToString() });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000002
            
                    #region VR.ATO.WRE.000003
            
                    /*  VR.ATO.WRE.000003
                    Car expenses - Log book method - business % claimed has a maximum length of 3
    
                    Legacy Rule Format:
                    IF LENGTH([wre17]) > 3
                         RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    Length(^WRE17) > 3
            
                    Data Elements:
            
                    RP.{CarSeqNum}:^WRE17 = tns:IncomeTax.Deduction.CarLogBookMethodBusinessUseClaimed.Percent
                    */
                    assertion = (Length(rpCarSeqNumContext.WRE17.GetValueOrDefault()) > 3);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000003", Severity = ProcessMessageSeverity.Error,
                            Description = @"Car expenses - Log book method - business % claimed must not exceed 3 characters",
                            LongDescription = @"For Car expenses - Log book method - business % claimed, the maximum allowable characters for this form is 3",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.CarLogBookMethodBusinessUseClaimed.Percent[@contextRef='" + rpCarSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000003"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE17", Value = rpCarSeqNumContext.WRE17.GetValueOrDefault().ToString() });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000003
            
                    #region VR.ATO.WRE.000004
            
                    /*  VR.ATO.WRE.000004
                    Car expenses - Total business kilometres (cents per km method only) has a maximum length of 4
    
                    Legacy Rule Format:
                    IF LENGTH([wre18]) > 4
                         RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    Length(^WRE18) > 4
            
                    Data Elements:
            
                    RP.{CarSeqNum}:^WRE18 = tns:IncomeTax.Deduction.CarBusinessKilometres.Number
                    */
                    assertion = (Length(rpCarSeqNumContext.WRE18.GetValueOrDefault()) > 4);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000004", Severity = ProcessMessageSeverity.Error,
                            Description = @"Car expenses - Total business kilometres (cents per km method only) must not exceed 4 characters",
                            LongDescription = @"For Car expenses - Total business kilometres (cents per km method only), the maximum allowable characters for this form is 4",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.CarBusinessKilometres.Number[@contextRef='" + rpCarSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000004"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE18", Value = rpCarSeqNumContext.WRE18.GetValueOrDefault().ToString() });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000004
            
                    #region VR.ATO.WRE.000006
            
                    /*  VR.ATO.WRE.000006
                    Car expenses - Details of "other" evidence/calculation code used has a maximum length of 240
    
                    Legacy Rule Format:
                    IF (LENGTH([wre21])) > 240
                         RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (Length(^WRE21)) > 240
            
                    Data Elements:
            
                    RP.{CarSeqNum}:^WRE21 = tns:IncomeTax.Deduction.CarStandardEvidenceCalculationOther.Description
                    */
                    assertion = (Length(rpCarSeqNumContext.WRE21) > 240);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000006", Severity = ProcessMessageSeverity.Error,
                            Description = @"Car expenses - Details of ""other"" evidence/calculation code used must not exceed 240 characters",
                            LongDescription = @"For Car expenses - Details of ""other"" evidence/calculation code used, the maximum allowable characters for this form is 240",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.CarStandardEvidenceCalculationOther.Description[@contextRef='" + rpCarSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000006"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE21", Value = rpCarSeqNumContext.WRE21 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000006
            
                    #region VR.ATO.WRE.000007
            
                    /*  VR.ATO.WRE.000007
                    Car expenses - Amount has a maximum field length of 11
    
                    Legacy Rule Format:
                    IF [wre22] <> MONETARY(U,11,0)
                         RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    NotMonetary(^WRE22, 'U', 11, 0)
            
                    Data Elements:
            
                    RP.{CarSeqNum}:^WRE22 = tns:IncomeTax.Deduction.Car.Amount
                    */
                    assertion = NotMonetary(rpCarSeqNumContext.WRE22, @"U", 11, 0);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000007", Severity = ProcessMessageSeverity.Error,
                            Description = @"Car expenses - Amount is not in a valid monetary format",
                            LongDescription = @"Car expenses - Amount must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.Car.Amount[@contextRef='" + rpCarSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000007"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE22", Value = rpCarSeqNumContext.WRE22.GetValueOrDefault().ToString() });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000007
            
                    #region VR.ATO.WRE.000027
            
                    /*  VR.ATO.WRE.000027
                    A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
                    Legacy Rule Format:
                    IF ([wre13] <> NULLORBLANK) AND (ANY CHARACTER OF [wre13] <> SET("a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    NotCharacterInSet(^WRE13, '"a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "')
            
                    Data Elements:
            
                    RP.{CarSeqNum}:^WRE13 = tns:Assets.CarMakeModel.Description
                    */
                    assertion = !string.IsNullOrWhiteSpace(rpCarSeqNumContext.WRE13) && !(IsMatch(rpCarSeqNumContext.WRE13, @"^[a-zA-Z0-9!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ]*$", RegexOptions.IgnoreCase));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000027", Severity = ProcessMessageSeverity.Error,
                            Description = @"Car expenses - Description of car (make, model) contains invalid text",
                            LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                            Location = "/xbrli:xbrl/tns:Assets.CarMakeModel.Description[@contextRef='" + rpCarSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000027"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE13", Value = rpCarSeqNumContext.WRE13 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000027
            
                    #region VR.ATO.WRE.000028
            
                    /*  VR.ATO.WRE.000028
                    A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
                    Legacy Rule Format:
                    IF ([wre21] <> NULLORBLANK) AND (ANY CHARACTER OF [wre21] <> SET("a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    NotCharacterInSet(^WRE21, '"a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "')
            
                    Data Elements:
            
                    RP.{CarSeqNum}:^WRE21 = tns:IncomeTax.Deduction.CarStandardEvidenceCalculationOther.Description
                    */
                    assertion = !string.IsNullOrWhiteSpace(rpCarSeqNumContext.WRE21) && !(IsMatch(rpCarSeqNumContext.WRE21, @"^[a-zA-Z0-9!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ]*$", RegexOptions.IgnoreCase));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000028", Severity = ProcessMessageSeverity.Error,
                            Description = @"Car expenses - Details of ""other"" evidence/calculation code used contains invalid text",
                            LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.CarStandardEvidenceCalculationOther.Description[@contextRef='" + rpCarSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000028"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE21", Value = rpCarSeqNumContext.WRE21 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000028
            
                    #region VR.ATO.WRE.000044
            
                    /*  VR.ATO.WRE.000044
                    A value is present at Car expenses - Log book method - business % claimed without Car expenses - Log book method - Business % shown in log book being present
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{CarSeqNum}) 
                    IF ([wre17] <> NULL AND [wre16] = NULL)
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (^WRE17 <> NULL AND ^WRE16 = NULL)
            
                    Data Elements:
            
                    RP.{CarSeqNum}:^WRE16 = tns:IncomeTax.Deduction.CarLogBookMethodBusinessUseRecorded.Percent
            
                    RP.{CarSeqNum}:^WRE17 = tns:IncomeTax.Deduction.CarLogBookMethodBusinessUseClaimed.Percent
                    */
                    assertion = (rpCarSeqNumContext.WRE17 != null && rpCarSeqNumContext.WRE16 == null);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000044", Severity = ProcessMessageSeverity.Error,
                            Description = @"Car expenses - Log book method - Business % shown in log book is invalid",
                            LongDescription = @"When a value has been provided for 'Car expenses - Log book method - Business % shown in log book', the 'Car expenses - Log book method - business % claimed' must be provided",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.CarLogBookMethodBusinessUseRecorded.Percent[@contextRef='" + rpCarSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000044"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE17", Value = rpCarSeqNumContext.WRE17.GetValueOrDefault().ToString() });
            
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE16", Value = rpCarSeqNumContext.WRE16.GetValueOrDefault().ToString() });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000044
            
                    #region VR.ATO.WRE.000045
            
                    /*  VR.ATO.WRE.000045
                    Car expenses - Claim code is set to "Logbook" and Car expenses - Log book method - Business % shown in log book is absent
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{CarSeqNum}) 
                    IF ([wre15] = "Logbook" AND [wre16] = NULL)
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (^WRE15 = 'Logbook' AND ^WRE16 = NULL)
            
                    Data Elements:
            
                    RP.{CarSeqNum}:^WRE16 = tns:IncomeTax.Deduction.CarLogBookMethodBusinessUseRecorded.Percent
            
                    RP.{CarSeqNum}:^WRE15 = tns:IncomeTax.Deduction.CarCalculationMethod.Code
                    */
                    assertion = (rpCarSeqNumContext.WRE15 == @"Logbook" && rpCarSeqNumContext.WRE16 == null);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000045", Severity = ProcessMessageSeverity.Error,
                            Description = @"Car expenses - Log book method - Business % shown in log book is required",
                            LongDescription = @"When 'Car expenses - Claim code' is set to ""Logbook"", the 'Car expenses - Log book method - Business % shown in log book' must be provided",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.CarLogBookMethodBusinessUseRecorded.Percent[@contextRef='" + rpCarSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000045"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE15", Value = rpCarSeqNumContext.WRE15 });
            
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE16", Value = rpCarSeqNumContext.WRE16.GetValueOrDefault().ToString() });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000045
            
                    #region VR.ATO.WRE.000046
            
                    /*  VR.ATO.WRE.000046
                    A value has been entered at Car expenses - Log book method - Business % shown in log book and Car expenses - Log book method - business % claimed is not present
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{CarSeqNum}) 
                    IF ([wre16] <> NULL AND [wre17] = NULL)
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (^WRE16 <> NULL AND ^WRE17 = NULL)
            
                    Data Elements:
            
                    RP.{CarSeqNum}:^WRE17 = tns:IncomeTax.Deduction.CarLogBookMethodBusinessUseClaimed.Percent
            
                    RP.{CarSeqNum}:^WRE16 = tns:IncomeTax.Deduction.CarLogBookMethodBusinessUseRecorded.Percent
                    */
                    assertion = (rpCarSeqNumContext.WRE16 != null && rpCarSeqNumContext.WRE17 == null);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000046", Severity = ProcessMessageSeverity.Error,
                            Description = @"Car expenses - Log book method - business % claimed is invalid",
                            LongDescription = @"When a value has been provided for 'Car expenses - Log book method - Business % shown in log book', the 'Car expenses - Log book method - business % claimed' must be provided",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.CarLogBookMethodBusinessUseClaimed.Percent[@contextRef='" + rpCarSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000046"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE16", Value = rpCarSeqNumContext.WRE16.GetValueOrDefault().ToString() });
            
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE17", Value = rpCarSeqNumContext.WRE17.GetValueOrDefault().ToString() });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000046
            
                    #region VR.ATO.WRE.000047
            
                    /*  VR.ATO.WRE.000047
                    The Car expenses - Claim code is set to "Cents per kilometre" in the attached Schedule of Work Related Expenses and Car expenses - Total business kilometres (cents per km method only) exceeds the limit of 5000 kilometres.
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{CarSeqNum}) 
                    IF ([wre15] = "Cents per kilometre" AND [wre18] > 5000)
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (^WRE15 = 'Cents per kilometre' AND ^WRE18 > 5000)
            
                    Data Elements:
            
                    RP.{CarSeqNum}:^WRE18 = tns:IncomeTax.Deduction.CarBusinessKilometres.Number
            
                    RP.{CarSeqNum}:^WRE15 = tns:IncomeTax.Deduction.CarCalculationMethod.Code
                    */
                    assertion = (rpCarSeqNumContext.WRE15 == @"Cents per kilometre" && rpCarSeqNumContext.WRE18.GetValueOrDefault() > 5000);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000047", Severity = ProcessMessageSeverity.Error,
                            Description = @"Car expenses - Total business kilometres (cents per km method only) allowable has been exceeded",
                            LongDescription = @"When 'Car expenses - Claim code' is set to ""Cents per kilometre"", the 'Car expenses - Total business kilometres (cents per km method only)' must not exceed 5000 kilometres",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.CarBusinessKilometres.Number[@contextRef='" + rpCarSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000047"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE15", Value = rpCarSeqNumContext.WRE15 });
            
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE18", Value = rpCarSeqNumContext.WRE18.GetValueOrDefault().ToString() });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000047
            
                    #region VR.ATO.WRE.000049
            
                    /*  VR.ATO.WRE.000049
                    A Schedule of Work Related Expenses is attached and Car expenses - Claim code is equal to "Logbook" and the Car expenses - Standard evidence/calculation information code is not equal to either: "Invoice receipt" or "PAYG summary" or "Dairy evidence" or "Allowance" or "ATO ruling" or "Diary calculation" or "Actual recorded cost" or "Log book" or "Other evidence" or "Other calculation"
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{CarSeqNum})
                    IF ([wre15]  = "Logbook" AND [wre20] <> SET("Invoice receipt", "PAYG summary", "Diary evidence", "Allowance", "ATO ruling", "Diary calculation", "Actual recorded cost", "Log book", "Other evidence", "Other calculation"))
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (^WRE15 = 'Logbook' AND NotInSet(^WRE20, '"Invoice receipt", "PAYG summary", "Diary evidence", "Allowance", "ATO ruling", "Diary calculation", "Actual recorded cost", "Log book", "Other evidence", "Other calculation"'))
            
                    Data Elements:
            
                    RP.{CarSeqNum}:^WRE20 = tns:IncomeTax.Deduction.CarStandardEvidenceCalculation.Code
            
                    RP.{CarSeqNum}:^WRE15 = tns:IncomeTax.Deduction.CarCalculationMethod.Code
                    */
                    assertion = (rpCarSeqNumContext.WRE15 == @"Logbook" && !(IsMatch(rpCarSeqNumContext.WRE20, @"^(Invoice receipt|PAYG summary|Diary evidence|Allowance|ATO ruling|Diary calculation|Actual recorded cost|Log book|Other evidence|Other calculation)$",RegexOptions.IgnoreCase)));
                    if (assertion)
                    {
                        // TODO:  This error message was taken from the business rule rather than the repository - this needs to be resolved.
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.020049", Severity = ProcessMessageSeverity.Error,
                            Description = @"Car expenses - Standard evidence/calculation information code is invalid",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.CarStandardEvidenceCalculation.Code[@contextRef='" + rpCarSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000049"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE15", Value = rpCarSeqNumContext.WRE15 });
            
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE20", Value = rpCarSeqNumContext.WRE20 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000049
            
                    #region VR.ATO.WRE.000051
            
                    /*  VR.ATO.WRE.000051
                    A Schedule of Work Related Expenses is attached and Car expenses - Standard evidence/calculation information code is set to either "Other evidence" or "Other expenses" and Car expenses - Details of "other" evidence/calculation code used is not present in the schedule
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{CarSeqNum})
                    IF ([wre20] = SET("Other evidence", "Other calculation") AND [wre21] = NULLORBLANK)
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (InSet(^WRE20, '"Other evidence", "Other calculation"') AND ^WRE21 = BLANK)
            
                    Data Elements:
            
                    RP.{CarSeqNum}:^WRE21 = tns:IncomeTax.Deduction.CarStandardEvidenceCalculationOther.Description
            
                    RP.{CarSeqNum}:^WRE20 = tns:IncomeTax.Deduction.CarStandardEvidenceCalculation.Code
                    */
                    assertion = (IsMatch(rpCarSeqNumContext.WRE20, @"^(Other evidence|Other calculation)$") && string.IsNullOrWhiteSpace(rpCarSeqNumContext.WRE21) == true);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000051", Severity = ProcessMessageSeverity.Error,
                            Description = @"Car expenses - Details of ""other"" evidence/calculation code used is required",
                            LongDescription = @"When 'Car expenses - Standard evidence/calculation information code' is set to either ""Other evidence"" or ""Other calculation"", the 'Car expenses - Details of ""other"" evidence/calculation code used' must be provided",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.CarStandardEvidenceCalculationOther.Description[@contextRef='" + rpCarSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000051"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE20", Value = rpCarSeqNumContext.WRE20 });
            
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE21", Value = rpCarSeqNumContext.WRE21 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000051
            
                    #region VR.ATO.WRE.000082
            
                    /*  VR.ATO.WRE.000082
                    Numeric field, values nnn where n is a digit 0 to 9 only to be used.
    
                    Legacy Rule Format:
                    IF ([wre16] <> NULL) AND (ANY CHARACTER OF [wre16] <> SET(0-9))
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    NotCharacterInSet(^WRE16, '0-9')
            
                    Data Elements:
            
                    RP.{CarSeqNum}:^WRE16 = tns:IncomeTax.Deduction.CarLogBookMethodBusinessUseRecorded.Percent
                    */
                    assertion = !(IsMatch(rpCarSeqNumContext.WRE16.GetValueOrDefault().ToString(), @"^[0-9]*$",RegexOptions.IgnoreCase));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000082", Severity = ProcessMessageSeverity.Error,
                            Description = @"'Car expenses - Log book method - Business % shown in log book' must be numeric",
                            LongDescription = @"'Car expenses - Log book method - Business % shown in log book' must be a numeric field, values nnn where n is a digit 0 to 9 only to be used.",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.CarLogBookMethodBusinessUseRecorded.Percent[@contextRef='" + rpCarSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000082"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE16", Value = rpCarSeqNumContext.WRE16.GetValueOrDefault().ToString() });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000082
            
                    #region VR.ATO.WRE.000083
            
                    /*  VR.ATO.WRE.000083
                    Numeric field, values nnn where n is a digit 0 to 9 only to be used.
    
                    Legacy Rule Format:
                    IF ([wre17] <> NULL) AND (ANY CHARACTER OF [wre17] <> SET(0-9))
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    NotCharacterInSet(^WRE17, '0-9')
            
                    Data Elements:
            
                    RP.{CarSeqNum}:^WRE17 = tns:IncomeTax.Deduction.CarLogBookMethodBusinessUseClaimed.Percent
                    */
                    assertion = !(IsMatch(rpCarSeqNumContext.WRE17.GetValueOrDefault().ToString(), @"^[0-9]*$",RegexOptions.IgnoreCase));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000083", Severity = ProcessMessageSeverity.Error,
                            Description = @"'Car expenses - Log book method - business % claimed' must be numeric",
                            LongDescription = @"'Car expenses - Log book method - business % claimed' must be a numeric field, values nnn where n is a digit 0 to 9 only to be used.",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.CarLogBookMethodBusinessUseClaimed.Percent[@contextRef='" + rpCarSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000083"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE17", Value = rpCarSeqNumContext.WRE17.GetValueOrDefault().ToString() });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000083
            
                    #region VR.ATO.WRE.000102
            
                    /*  VR.ATO.WRE.000102
                    Value entered is not a valid code/value for that field.
    
                    Legacy Rule Format:
                    IF ([wre15] <> NULLORBLANK) AND ([wre15] <> SET("Cents per kilometre","Logbook"))
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (^WRE15 <> BLANK) AND (NotInSet(^WRE15, '"Cents per kilometre","Logbook"'))
            
                    Data Elements:
            
                    RP.{CarSeqNum}:^WRE15 = tns:IncomeTax.Deduction.CarCalculationMethod.Code
                    */
                    assertion = (string.IsNullOrWhiteSpace(rpCarSeqNumContext.WRE15) != true && !(IsMatch(rpCarSeqNumContext.WRE15, @"^(Cents per kilometre|Logbook)$",RegexOptions.IgnoreCase)));
                    if (assertion)
                    {
                        // TODO:  This error message was taken from the business rule rather than the repository - this needs to be resolved.
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000102", Severity = ProcessMessageSeverity.Error,
                            Description = @"Invalid code provided",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.CarCalculationMethod.Code[@contextRef='" + rpCarSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000102"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE15", Value = rpCarSeqNumContext.WRE15 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000102
                    }
                }
        
                #endregion // Foreach loop

            #region Repeating RPTrvlSeqNumContext
            if (report.RPTrvlSeqNumContextCollection != null)
            {
                int itemIndexContext2 = 0;
                foreach (WRE2017.RPTrvlSeqNumContext rpTrvlSeqNumContext in report.RPTrvlSeqNumContextCollection)
                {
                    itemIndexContext2++;
            
                    #region VR.ATO.WRE.000008
            
                    /*  VR.ATO.WRE.000008
                    Other travel expenses - Details of "other" code used has a maximum length of 40
    
                    Legacy Rule Format:
                    IF (LENGTH([wre26])) > 40
                         RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (Length(^WRE26)) > 40
            
                    Data Elements:
            
                    RP.{TrvlSeqNum}:^WRE26 = tns:IncomeTax.Deduction.TravelCategoryOther.Description
                    */
                    assertion = (Length(rpTrvlSeqNumContext.WRE26) > 40);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000008", Severity = ProcessMessageSeverity.Error,
                            Description = @"Other travel expenses - Details of ""other"" code used must not exceed 40 characters",
                            LongDescription = @"For Other travel expenses - Details of ""other"" code used, the maximum allowable characters for this form is 40",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.TravelCategoryOther.Description[@contextRef='" + rpTrvlSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000008"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE26", Value = rpTrvlSeqNumContext.WRE26 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000008
            
                    #region VR.ATO.WRE.000009
            
                    /*  VR.ATO.WRE.000009
                    Other travel expenses - Details of "other" evidence/calculation code used has a maximum length of 240
    
                    Legacy Rule Format:
                    IF (LENGTH([wre28])) > 240
                         RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (Length(^WRE28)) > 240
            
                    Data Elements:
            
                    RP.{TrvlSeqNum}:^WRE28 = tns:IncomeTax.Deduction.TravelStandardEvidenceCalculationOther.Description
                    */
                    assertion = (Length(rpTrvlSeqNumContext.WRE28) > 240);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000009", Severity = ProcessMessageSeverity.Error,
                            Description = @"Other travel expenses - Details of ""other"" evidence/calculation code used must not exceed 240 characters",
                            LongDescription = @"For Other travel expenses - Details of ""other"" evidence/calculation code used, the maximum allowable characters for this form is 240",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.TravelStandardEvidenceCalculationOther.Description[@contextRef='" + rpTrvlSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000009"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE28", Value = rpTrvlSeqNumContext.WRE28 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000009
            
                    #region VR.ATO.WRE.000010
            
                    /*  VR.ATO.WRE.000010
                    Other travel expenses - Amount has a maximum field length of 11
    
                    Legacy Rule Format:
                    IF [wre29] <> MONETARY(U,11,0)
                         RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    NotMonetary(^WRE29, 'U', 11, 0)
            
                    Data Elements:
            
                    RP.{TrvlSeqNum}:^WRE29 = tns:IncomeTax.Deduction.Travel.Amount
                    */
                    assertion = NotMonetary(rpTrvlSeqNumContext.WRE29, @"U", 11, 0);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000010", Severity = ProcessMessageSeverity.Error,
                            Description = @"Other travel expenses - Amount is not in a valid monetary format",
                            LongDescription = @"Other travel expenses - Amount must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.Travel.Amount[@contextRef='" + rpTrvlSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000010"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE29", Value = rpTrvlSeqNumContext.WRE29.GetValueOrDefault().ToString() });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000010
            
                    #region VR.ATO.WRE.000030
            
                    /*  VR.ATO.WRE.000030
                    A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
                    Legacy Rule Format:
                    IF ([wre26] <> NULLORBLANK) AND (ANY CHARACTER OF [wre26] <> SET("a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    NotCharacterInSet(^WRE26, '"a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "')
            
                    Data Elements:
            
                    RP.{TrvlSeqNum}:^WRE26 = tns:IncomeTax.Deduction.TravelCategoryOther.Description
                    */
                    assertion = !string.IsNullOrWhiteSpace(rpTrvlSeqNumContext.WRE26) && !(IsMatch(rpTrvlSeqNumContext.WRE26, @"^[a-zA-Z0-9!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ]*$", RegexOptions.IgnoreCase));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000030", Severity = ProcessMessageSeverity.Error,
                            Description = @"Other travel expenses - Details of ""other"" code used contains invalid text",
                            LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.TravelCategoryOther.Description[@contextRef='" + rpTrvlSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000030"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE26", Value = rpTrvlSeqNumContext.WRE26 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000030
            
                    #region VR.ATO.WRE.000031
            
                    /*  VR.ATO.WRE.000031
                    A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
                    Legacy Rule Format:
                    IF ([wre28] <> NULLORBLANK) AND (ANY CHARACTER OF [wre28] <> SET("a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    NotCharacterInSet(^WRE28, '"a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "')
            
                    Data Elements:
            
                    RP.{TrvlSeqNum}:^WRE28 = tns:IncomeTax.Deduction.TravelStandardEvidenceCalculationOther.Description
                    */
                    assertion = !string.IsNullOrWhiteSpace(rpTrvlSeqNumContext.WRE28) && !(IsMatch(rpTrvlSeqNumContext.WRE28, @"^[a-zA-Z0-9!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ]*$", RegexOptions.IgnoreCase));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000031", Severity = ProcessMessageSeverity.Error,
                            Description = @"Other travel expenses - Details of ""other"" evidence/calculation code used contains invalid text",
                            LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.TravelStandardEvidenceCalculationOther.Description[@contextRef='" + rpTrvlSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000031"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE28", Value = rpTrvlSeqNumContext.WRE28 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000031
            
                    #region VR.ATO.WRE.000056
            
                    /*  VR.ATO.WRE.000056
                    A Schedule of Work Related Expenses is attached and Other travel expenses - Category of expense is set to either "Vehicles" or "Other" and Other travel expenses - Standard evidence/calculation code is not set to to "Invoice receipt" or "PAYG summary" or "Diary evidence" or "Allowance received" or "No Substantiation" or "Other evidence"
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{TrvlSeqNum}) 
                    IF ([wre25] = SET("Vehicles", "Other") AND [wre27] <> SET("Invoice receipt", "PAYG summary", "Diary evidence", "Allowance", "No Substantiation", "Other evidence"))
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (InSet(^WRE25, '"Vehicles", "Other"') AND NotInSet(^WRE27, '"Invoice receipt", "PAYG summary", "Diary evidence", "Allowance", "No Substantiation", "Other evidence"'))
            
                    Data Elements:
            
                    RP.{TrvlSeqNum}:^WRE27 = tns:IncomeTax.Deduction.TravelStandardEvidenceCalculation.Code
            
                    RP.{TrvlSeqNum}:^WRE25 = tns:IncomeTax.Deduction.TravelCategory.Code
                    */
                    assertion = (IsMatch(rpTrvlSeqNumContext.WRE25, @"^(Vehicles|Other)$") && !(IsMatch(rpTrvlSeqNumContext.WRE27, @"^(Invoice receipt|PAYG summary|Diary evidence|Allowance|No Substantiation|Other evidence)$",RegexOptions.IgnoreCase)));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000056", Severity = ProcessMessageSeverity.Error,
                            Description = @"Other travel expenses - Standard evidence/calculation code is invalid",
                            LongDescription = @"When 'Other travel expenses - Category of expense' is set to either ""Vehicles"" or ""Other"", the associated valid codes for 'Other travel expenses - Standard evidence/calculation code' are; ""Invoice receipt"", ""PAYG summary"", ""Diary evidence"", ""Allowance"", ""No Substantiation"" or ""Other evidence""",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.TravelStandardEvidenceCalculation.Code[@contextRef='" + rpTrvlSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000056"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE25", Value = rpTrvlSeqNumContext.WRE25 });
            
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE27", Value = rpTrvlSeqNumContext.WRE27 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000056
            
                    #region VR.ATO.WRE.000057
            
                    /*  VR.ATO.WRE.000057
                    A Schedule of Work Related Expenses is attached and Other travel expenses - Category of expense is set to either "Domestic", "Award" or "Overseas" and Other travel expenses - Standard evidence/calculation code is not present
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{TrvlSeqNum}) 
                    IF ([wre25] = SET("Award", "Domestic", "Overseas") AND [wre27] = NULLORBLANK)
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (InSet(^WRE25, '"Award", "Domestic", "Overseas"') AND ^WRE27 = BLANK)
            
                    Data Elements:
            
                    RP.{TrvlSeqNum}:^WRE27 = tns:IncomeTax.Deduction.TravelStandardEvidenceCalculation.Code
            
                    RP.{TrvlSeqNum}:^WRE25 = tns:IncomeTax.Deduction.TravelCategory.Code
                    */
                    assertion = (IsMatch(rpTrvlSeqNumContext.WRE25, @"^(Award|Domestic|Overseas)$") && string.IsNullOrWhiteSpace(rpTrvlSeqNumContext.WRE27) == true);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000057", Severity = ProcessMessageSeverity.Error,
                            Description = @"Other travel expenses - Standard evidence/calculation code is required",
                            LongDescription = @"When 'Other travel expenses - Category of expense' is set to either ""Domestic"" or ""Overseas"", the 'Other travel expenses - Standard evidence/calculation code' must be provided",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.TravelStandardEvidenceCalculation.Code[@contextRef='" + rpTrvlSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000057"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE25", Value = rpTrvlSeqNumContext.WRE25 });
            
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE27", Value = rpTrvlSeqNumContext.WRE27 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000057
            
                    #region VR.ATO.WRE.000058
            
                    /*  VR.ATO.WRE.000058
                    Other travel expenses - Standard evidence/calculation code is set to either "Other Evidence" or "Other Calculation" on the attached Schedule of Work Related Expenses and Other travel expenses - Details of "other" evidence/calculation code used is not present
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{TrvlSeqNum}) 
                    IF ([wre27] = SET("Other evidence", "Other calculation") AND [wre28] = NULLORBLANK)
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (InSet(^WRE27, '"Other evidence", "Other calculation"') AND ^WRE28 = BLANK)
            
                    Data Elements:
            
                    RP.{TrvlSeqNum}:^WRE28 = tns:IncomeTax.Deduction.TravelStandardEvidenceCalculationOther.Description
            
                    RP.{TrvlSeqNum}:^WRE27 = tns:IncomeTax.Deduction.TravelStandardEvidenceCalculation.Code
                    */
                    assertion = (IsMatch(rpTrvlSeqNumContext.WRE27, @"^(Other evidence|Other calculation)$") && string.IsNullOrWhiteSpace(rpTrvlSeqNumContext.WRE28) == true);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000058", Severity = ProcessMessageSeverity.Error,
                            Description = @"Other travel expenses - Details of ""other"" evidence/calculation code used is required",
                            LongDescription = @"When 'Other travel expenses - Standard evidence/calculation code' is set to either ""Other Evidence"" or ""Other Calculation"", the 'Other travel expenses - Details of ""other"" evidence/calculation code used' must be provided",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.TravelStandardEvidenceCalculationOther.Description[@contextRef='" + rpTrvlSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000058"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE27", Value = rpTrvlSeqNumContext.WRE27 });
            
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE28", Value = rpTrvlSeqNumContext.WRE28 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000058
            
                    #region VR.ATO.WRE.000085
            
                    /*  VR.ATO.WRE.000085
                    When 'Other travel expenses - Category of expense' of "Other" is selected, then 'Other travel expenses - Details of "other" code used' must be provided
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{TrvlSeqNum})
                    IF [wre25] = "Other" AND [wre26] = NULLORBLANK
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    ^WRE25 = 'Other' AND ^WRE26 = BLANK
            
                    Data Elements:
            
                    RP.{TrvlSeqNum}:^WRE26 = tns:IncomeTax.Deduction.TravelCategoryOther.Description
            
                    RP.{TrvlSeqNum}:^WRE25 = tns:IncomeTax.Deduction.TravelCategory.Code
                    */
                    assertion = (rpTrvlSeqNumContext.WRE25 == @"Other" && string.IsNullOrWhiteSpace(rpTrvlSeqNumContext.WRE26) == true);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000085", Severity = ProcessMessageSeverity.Error,
                            Description = @"'Other travel expenses - Details of ""other"" code used' must be provided",
                            LongDescription = @"When 'Other travel expenses - Category of expense' of ""Other"" is selected, then 'Other travel expenses - Details of ""other"" code used' must be provided",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.TravelCategoryOther.Description[@contextRef='" + rpTrvlSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000085"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE25", Value = rpTrvlSeqNumContext.WRE25 });
            
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE26", Value = rpTrvlSeqNumContext.WRE26 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000085
                    }
                }
        
                #endregion // Foreach loop

            #region Repeating RPClthngSeqNumContext
            if (report.RPClthngSeqNumContextCollection != null)
            {
                int itemIndexContext2 = 0;
                foreach (WRE2017.RPClthngSeqNumContext rpClthngSeqNumContext in report.RPClthngSeqNumContextCollection)
                {
                    itemIndexContext2++;
            
                    #region VR.ATO.WRE.000011
            
                    /*  VR.ATO.WRE.000011
                    Clothing expenses - Details of "other" clothing category used has a maximum length of 40
    
                    Legacy Rule Format:
                    IF (LENGTH([wre33])) > 40
                         RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (Length(^WRE33)) > 40
            
                    Data Elements:
            
                    RP.{ClthngSeqNum}:^WRE33 = tns:IncomeTax.Deduction.ClothingCategoryOther.Description
                    */
                    assertion = (Length(rpClthngSeqNumContext.WRE33) > 40);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000011", Severity = ProcessMessageSeverity.Error,
                            Description = @"Clothing expenses - Details of ""other"" clothing category used must not exceed 40 characters",
                            LongDescription = @"For Clothing expenses - Details of ""other"" clothing category used, the maximum allowable characters for this form is 40",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.ClothingCategoryOther.Description[@contextRef='" + rpClthngSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000011"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE33", Value = rpClthngSeqNumContext.WRE33 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000011
            
                    #region VR.ATO.WRE.000012
            
                    /*  VR.ATO.WRE.000012
                    Clothing expenses - Details of "other" evidence/calculation code used has a maximum length of 240
    
                    Legacy Rule Format:
                    IF (LENGTH([wre35])) > 240
                         RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (Length(^WRE35)) > 240
            
                    Data Elements:
            
                    RP.{ClthngSeqNum}:^WRE35 = tns:IncomeTax.Deduction.ClothingStandardEvidenceCalculationOther.Description
                    */
                    assertion = (Length(rpClthngSeqNumContext.WRE35) > 240);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000012", Severity = ProcessMessageSeverity.Error,
                            Description = @"Clothing expenses - Details of ""other"" evidence/calculation code used must not exceed 240 characters",
                            LongDescription = @"For Clothing expenses - Details of ""other"" evidence/calculation code used, the maximum allowable characters for this form is 240",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.ClothingStandardEvidenceCalculationOther.Description[@contextRef='" + rpClthngSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000012"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE35", Value = rpClthngSeqNumContext.WRE35 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000012
            
                    #region VR.ATO.WRE.000013
            
                    /*  VR.ATO.WRE.000013
                    Clothing expenses - Amount has a maximum field length of 11
    
                    Legacy Rule Format:
                    IF ([wre36] <> MONETARY(U,11,0))
                         RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (NotMonetary(^WRE36, 'U', 11, 0))
            
                    Data Elements:
            
                    RP.{ClthngSeqNum}:^WRE36 = tns:IncomeTax.Deduction.Clothing.Amount
                    */
                    assertion = NotMonetary(rpClthngSeqNumContext.WRE36, @"U", 11, 0);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000013", Severity = ProcessMessageSeverity.Error,
                            Description = @"Clothing expenses - Amount is not in a valid monetary format",
                            LongDescription = @"Clothing expenses - Amount must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.Clothing.Amount[@contextRef='" + rpClthngSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000013"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE36", Value = rpClthngSeqNumContext.WRE36.GetValueOrDefault().ToString() });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000013
            
                    #region VR.ATO.WRE.000033
            
                    /*  VR.ATO.WRE.000033
                    A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
                    Legacy Rule Format:
                    IF ([wre33] <> NULLORBLANK) AND (ANY CHARACTER OF [wre33] <> SET("a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    NotCharacterInSet(^WRE33, '"a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "')
            
                    Data Elements:
            
                    RP.{ClthngSeqNum}:^WRE33 = tns:IncomeTax.Deduction.ClothingCategoryOther.Description
                    */
                    assertion = !string.IsNullOrWhiteSpace(rpClthngSeqNumContext.WRE33) && !(IsMatch(rpClthngSeqNumContext.WRE33, @"^[a-zA-Z0-9!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ]*$", RegexOptions.IgnoreCase));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000033", Severity = ProcessMessageSeverity.Error,
                            Description = @"Clothing expenses - Details of ""other"" clothing category used contains invalid text",
                            LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.ClothingCategoryOther.Description[@contextRef='" + rpClthngSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000033"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE33", Value = rpClthngSeqNumContext.WRE33 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000033
            
                    #region VR.ATO.WRE.000034
            
                    /*  VR.ATO.WRE.000034
                    A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
                    Legacy Rule Format:
                    IF ([wre35] <> NULLORBLANK) AND (ANY CHARACTER OF [wre35] <> SET("a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    NotCharacterInSet(^WRE35, '"a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "')
            
                    Data Elements:
            
                    RP.{ClthngSeqNum}:^WRE35 = tns:IncomeTax.Deduction.ClothingStandardEvidenceCalculationOther.Description
                    */
                    assertion = !string.IsNullOrWhiteSpace(rpClthngSeqNumContext.WRE35) && !(IsMatch(rpClthngSeqNumContext.WRE35, @"^[a-zA-Z0-9!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ]*$", RegexOptions.IgnoreCase));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000034", Severity = ProcessMessageSeverity.Error,
                            Description = @"Clothing expenses - Details of ""other"" evidence/calculation code used contains invalid text",
                            LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.ClothingStandardEvidenceCalculationOther.Description[@contextRef='" + rpClthngSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000034"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE35", Value = rpClthngSeqNumContext.WRE35 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000034
            
                    #region VR.ATO.WRE.000060
            
                    /*  VR.ATO.WRE.000060
                    A Schedule of Work Related Expenses is attached and Clothing expenses - Category is set to "Laundry" and Clothing expenses - Standard evidence/calculation information code is not present in the schedule
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{ClthngSeqNum}) 
                    IF ([wre32] = "Laundry" AND [wre34] = NULLORBLANK)
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (^WRE32 = 'Laundry' AND ^WRE34 = BLANK)
            
                    Data Elements:
            
                    RP.{ClthngSeqNum}:^WRE34 = tns:IncomeTax.Deduction.ClothingStandardEvidenceCalculation.Code
            
                    RP.{ClthngSeqNum}:^WRE32 = tns:IncomeTax.Deduction.ClothingCategory.Code
                    */
                    assertion = (rpClthngSeqNumContext.WRE32 == @"Laundry" && string.IsNullOrWhiteSpace(rpClthngSeqNumContext.WRE34) == true);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000060", Severity = ProcessMessageSeverity.Error,
                            Description = @"Clothing expenses - Standard evidence/calculation information code is required",
                            LongDescription = @"When 'Clothing expenses - Category' is set to ""Laundry"", the 'Clothing expenses - Standard evidence/calculation information code' must be provided",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.ClothingStandardEvidenceCalculation.Code[@contextRef='" + rpClthngSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000060"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE32", Value = rpClthngSeqNumContext.WRE32 });
            
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE34", Value = rpClthngSeqNumContext.WRE34 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000060
            
                    #region VR.ATO.WRE.000061
            
                    /*  VR.ATO.WRE.000061
                    A Schedule of Work Related Expenses is attached and Clothing expenses - Category  is set to either Dry cleaning, Protective clothing, Compulsory work uniform, Non-compulsory work uniform, Occupation specific clothing or Other and Clothing expenses - Standard evidence/calculation information code is not equal to either "Invoice receipt", "PAYG summary", "Diary evidence", "Allowance", "No Substantiation" or "Other evidence"
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{ClthngSeqNum}) 
                    IF ([wre32] = SET("Dry cleaning", "Protective clothing", "Compulsory work uniform", "Non-compulsory work uniform", "Occupation specific clothing", "Other") AND [wre34] <> SET("Invoice receipt", "PAYG summary", "Diary evidence", "Allowance", "No Substantiation", "Other evidence"))
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (InSet(^WRE32, '"Dry cleaning", "Protective clothing", "Compulsory work uniform", "Non-compulsory work uniform", "Occupation specific clothing", "Other"') AND NotInSet(^WRE34, '"Invoice receipt", "PAYG summary", "Diary evidence", "Allowance", "No Substantiation", "Other evidence"'))
            
                    Data Elements:
            
                    RP.{ClthngSeqNum}:^WRE34 = tns:IncomeTax.Deduction.ClothingStandardEvidenceCalculation.Code
            
                    RP.{ClthngSeqNum}:^WRE32 = tns:IncomeTax.Deduction.ClothingCategory.Code
                    */
                    assertion = (IsMatch(rpClthngSeqNumContext.WRE32, @"^(Dry cleaning|Protective clothing|Compulsory work uniform|Non-compulsory work uniform|Occupation specific clothing|Other)$") && !(IsMatch(rpClthngSeqNumContext.WRE34, @"^(Invoice receipt|PAYG summary|Diary evidence|Allowance|No Substantiation|Other evidence)$",RegexOptions.IgnoreCase)));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000061", Severity = ProcessMessageSeverity.Error,
                            Description = @"Clothing expenses - Standard evidence/calculation information code is invalid",
                            LongDescription = @"When 'Clothing expenses - Category' is set to either ""Dry cleaning"", ""Protective clothing"", ""Compulsory work uniform"", ""Non-compulsory work uniform"", ""Occupation specific clothing"" or ""Other"", the associated valid codes for 'Clothing expenses - Standard evidence/calculation information code' are; ""Invoice receipt"", ""PAYG summary"", ""Diary evidence"", ""Allowance"", ""No Substantiation"" or ""Other evidence""",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.ClothingStandardEvidenceCalculation.Code[@contextRef='" + rpClthngSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000061"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE32", Value = rpClthngSeqNumContext.WRE32 });
            
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE34", Value = rpClthngSeqNumContext.WRE34 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000061
            
                    #region VR.ATO.WRE.000062
            
                    /*  VR.ATO.WRE.000062
                    Clothing expenses - Standard evidence/calculation information code is present in an attached Schedule of Work Related Expenses with a value of either "Other evidence" or "Other calculation" and Clothing expenses - Details of "other" evidence/calculation code used is not present
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{ClthngSeqNum}) 
                    IF ([wre34] = SET("Other evidence", "Other calculation") AND [wre35] = NULLORBLANK)
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (InSet(^WRE34, '"Other evidence", "Other calculation"') AND ^WRE35 = BLANK)
            
                    Data Elements:
            
                    RP.{ClthngSeqNum}:^WRE35 = tns:IncomeTax.Deduction.ClothingStandardEvidenceCalculationOther.Description
            
                    RP.{ClthngSeqNum}:^WRE34 = tns:IncomeTax.Deduction.ClothingStandardEvidenceCalculation.Code
                    */
                    assertion = (IsMatch(rpClthngSeqNumContext.WRE34, @"^(Other evidence|Other calculation)$") && string.IsNullOrWhiteSpace(rpClthngSeqNumContext.WRE35) == true);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000062", Severity = ProcessMessageSeverity.Error,
                            Description = @"Clothing expenses - Details of ""other"" evidence/calculation code used is required",
                            LongDescription = @"When 'Clothing expenses - Standard evidence/calculation information code' is set to either ""Other evidence"" or ""Other calculation"", the 'Clothing expenses - Details of ""other"" evidence/calculation code used' must be provided",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.ClothingStandardEvidenceCalculationOther.Description[@contextRef='" + rpClthngSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000062"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE34", Value = rpClthngSeqNumContext.WRE34 });
            
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE35", Value = rpClthngSeqNumContext.WRE35 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000062
            
                    #region VR.ATO.WRE.000086
            
                    /*  VR.ATO.WRE.000086
                    When 'Clothing expenses - Category' of "Other" is selected, then 'Clothing expenses - Details of "other" clothing category used' must be provided
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{ClthngSeqNum})
                    IF [wre32] = "Other" AND [wre33] = NULLORBLANK
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    ^WRE32 = 'Other' AND ^WRE33 = BLANK
            
                    Data Elements:
            
                    RP.{ClthngSeqNum}:^WRE33 = tns:IncomeTax.Deduction.ClothingCategoryOther.Description
            
                    RP.{ClthngSeqNum}:^WRE32 = tns:IncomeTax.Deduction.ClothingCategory.Code
                    */
                    assertion = (rpClthngSeqNumContext.WRE32 == @"Other" && string.IsNullOrWhiteSpace(rpClthngSeqNumContext.WRE33) == true);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000086", Severity = ProcessMessageSeverity.Error,
                            Description = @"'Clothing expenses - Details of ""other"" clothing category used' must be provided",
                            LongDescription = @"When 'Clothing expenses - Category' of ""Other"" is selected, then 'Clothing expenses - Details of ""other"" clothing category used' must be provided",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.ClothingCategoryOther.Description[@contextRef='" + rpClthngSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000086"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE32", Value = rpClthngSeqNumContext.WRE32 });
            
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE33", Value = rpClthngSeqNumContext.WRE33 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000086
                    }
                }
        
                #endregion // Foreach loop

            #region Repeating RPEduSeqNumContext
            if (report.RPEduSeqNumContextCollection != null)
            {
                int itemIndexContext2 = 0;
                foreach (WRE2017.RPEduSeqNumContext rpEduSeqNumContext in report.RPEduSeqNumContextCollection)
                {
                    itemIndexContext2++;
            
                    #region VR.ATO.WRE.000015
            
                    /*  VR.ATO.WRE.000015
                    Self education expenses - Name of course has a maximum length of 20
    
                    Legacy Rule Format:
                    IF (LENGTH([wre39])) > 20
                         RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (Length(^WRE39)) > 20
            
                    Data Elements:
            
                    RP.{EduSeqNum}:^WRE39 = tns:Identifiers.CourseName.Text
                    */
                    assertion = (Length(rpEduSeqNumContext.WRE39) > 20);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000015", Severity = ProcessMessageSeverity.Error,
                            Description = @"Self education expenses - Name of course must not exceed 20 characters",
                            LongDescription = @"For Self education expenses - Name of course, the maximum allowable characters for this form is 20",
                            Location = "/xbrli:xbrl/tns:Identifiers.CourseName.Text[@contextRef='" + rpEduSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000015"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE39", Value = rpEduSeqNumContext.WRE39 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000015
            
                    #region VR.ATO.WRE.000016
            
                    /*  VR.ATO.WRE.000016
                    Self education expenses - Institution has a maximum length of 20
    
                    Legacy Rule Format:
                    IF (LENGTH([wre40])) > 20
                         RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (Length(^WRE40)) > 20
            
                    Data Elements:
            
                    RP.{EduSeqNum}:^WRE40 = tns:Identifiers.InstitutionName.Text
                    */
                    assertion = (Length(rpEduSeqNumContext.WRE40) > 20);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000016", Severity = ProcessMessageSeverity.Error,
                            Description = @"Self education expenses - Institution must not exceed 20 characters",
                            LongDescription = @"For Self education expenses - Institution, the maximum allowable characters for this form is 20",
                            Location = "/xbrli:xbrl/tns:Identifiers.InstitutionName.Text[@contextRef='" + rpEduSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000016"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE40", Value = rpEduSeqNumContext.WRE40 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000016
            
                    #region VR.ATO.WRE.000017
            
                    /*  VR.ATO.WRE.000017
                    Self education expenses - Details of "other" category used has a maximum length of 40
    
                    Legacy Rule Format:
                    IF (LENGTH([wre42])) > 40
                         RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (Length(^WRE42)) > 40
            
                    Data Elements:
            
                    RP.{EduSeqNum}:^WRE42 = tns:IncomeTax.Deduction.EducationCategoryOther.Description
                    */
                    assertion = (Length(rpEduSeqNumContext.WRE42) > 40);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000017", Severity = ProcessMessageSeverity.Error,
                            Description = @"Self education expenses - Details of ""other"" category used must not exceed 40 characters",
                            LongDescription = @"For Self education expenses - Details of ""other"" category used, the maximum allowable characters for this form is 40",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.EducationCategoryOther.Description[@contextRef='" + rpEduSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000017"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE42", Value = rpEduSeqNumContext.WRE42 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000017
            
                    #region VR.ATO.WRE.000018
            
                    /*  VR.ATO.WRE.000018
                    Self education expenses - Explanation of "other" evidence/calculation code used has a maximum length of 240
    
                    Legacy Rule Format:
                    IF (LENGTH([wre44])) > 240
                         RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (Length(^WRE44)) > 240
            
                    Data Elements:
            
                    RP.{EduSeqNum}:^WRE44 = tns:IncomeTax.Deduction.EducationStandardEvidenceCalculationOther.Description
                    */
                    assertion = (Length(rpEduSeqNumContext.WRE44) > 240);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000018", Severity = ProcessMessageSeverity.Error,
                            Description = @"Self education expenses - Explanation of ""other"" evidence/calculation code used must not exceed 240 characters",
                            LongDescription = @"For Self education expenses - Explanation of ""other"" evidence/calculation code used, the maximum allowable characters for this form is 240",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.EducationStandardEvidenceCalculationOther.Description[@contextRef='" + rpEduSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000018"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE44", Value = rpEduSeqNumContext.WRE44 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000018
            
                    #region VR.ATO.WRE.000019
            
                    /*  VR.ATO.WRE.000019
                    Self education expenses - Gross amount has a maximum field length of 11
    
                    Legacy Rule Format:
                    IF ([wre45] <> MONETARY(U,11,0))
                         RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (NotMonetary(^WRE45, 'U', 11, 0))
            
                    Data Elements:
            
                    RP.{EduSeqNum}:^WRE45 = tns:IncomeTax.Deduction.Education.Amount
                    */
                    assertion = NotMonetary(rpEduSeqNumContext.WRE45, @"U", 11, 0);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000019", Severity = ProcessMessageSeverity.Error,
                            Description = @"Self education expenses - Gross amount is not in a valid monetary format",
                            LongDescription = @"Self education expenses - Gross amount must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.Education.Amount[@contextRef='" + rpEduSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000019"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE45", Value = rpEduSeqNumContext.WRE45.GetValueOrDefault().ToString() });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000019
            
                    #region VR.ATO.WRE.000036
            
                    /*  VR.ATO.WRE.000036
                    A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{EduSeqNum}) 
                    IF ([wre39] <> NULLORBLANK) AND (ANY CHARACTER OF [wre39] <> SET("a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    NotCharacterInSet(^WRE39, '"a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "')
            
                    Data Elements:
            
                    RP.{EduSeqNum}:^WRE39 = tns:Identifiers.CourseName.Text
                    */
                    assertion = !string.IsNullOrWhiteSpace(rpEduSeqNumContext.WRE39) && !(IsMatch(rpEduSeqNumContext.WRE39, @"^[a-zA-Z0-9!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ]*$", RegexOptions.IgnoreCase));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000036", Severity = ProcessMessageSeverity.Error,
                            Description = @"Self education expenses - Name of course contains invalid text",
                            LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                            Location = "/xbrli:xbrl/tns:Identifiers.CourseName.Text[@contextRef='" + rpEduSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000036"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE39", Value = rpEduSeqNumContext.WRE39 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000036
            
                    #region VR.ATO.WRE.000037
            
                    /*  VR.ATO.WRE.000037
                    A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{EduSeqNum}) 
                    IF ([wre40] <> NULLORBLANK) AND (ANY CHARACTER OF [wre40] <> SET("a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    NotCharacterInSet(^WRE40, '"a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "')
            
                    Data Elements:
            
                    RP.{EduSeqNum}:^WRE40 = tns:Identifiers.InstitutionName.Text
                    */
                    assertion = !string.IsNullOrWhiteSpace(rpEduSeqNumContext.WRE40) && !(IsMatch(rpEduSeqNumContext.WRE40, @"^[a-zA-Z0-9!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ]*$", RegexOptions.IgnoreCase));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000037", Severity = ProcessMessageSeverity.Error,
                            Description = @"Self education expenses - Institution contains invalid text",
                            LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                            Location = "/xbrli:xbrl/tns:Identifiers.InstitutionName.Text[@contextRef='" + rpEduSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000037"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE40", Value = rpEduSeqNumContext.WRE40 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000037
            
                    #region VR.ATO.WRE.000038
            
                    /*  VR.ATO.WRE.000038
                    A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
                    Legacy Rule Format:
                    IF ([wre42] <> NULLORBLANK) AND (ANY CHARACTER OF [wre42] <> SET("a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    NotCharacterInSet(^WRE42, '"a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "')
            
                    Data Elements:
            
                    RP.{EduSeqNum}:^WRE42 = tns:IncomeTax.Deduction.EducationCategoryOther.Description
                    */
                    assertion = !string.IsNullOrWhiteSpace(rpEduSeqNumContext.WRE42) && !(IsMatch(rpEduSeqNumContext.WRE42, @"^[a-zA-Z0-9!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ]*$", RegexOptions.IgnoreCase));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000038", Severity = ProcessMessageSeverity.Error,
                            Description = @"Self education expenses - Details of ""other"" category used contains invalid text",
                            LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.EducationCategoryOther.Description[@contextRef='" + rpEduSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000038"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE42", Value = rpEduSeqNumContext.WRE42 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000038
            
                    #region VR.ATO.WRE.000039
            
                    /*  VR.ATO.WRE.000039
                    A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
                    Legacy Rule Format:
                    IF ([wre44] <> NULLORBLANK) AND (ANY CHARACTER OF [wre44] <> SET("a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    NotCharacterInSet(^WRE44, '"a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "')
            
                    Data Elements:
            
                    RP.{EduSeqNum}:^WRE44 = tns:IncomeTax.Deduction.EducationStandardEvidenceCalculationOther.Description
                    */
                    assertion = !string.IsNullOrWhiteSpace(rpEduSeqNumContext.WRE44) && !(IsMatch(rpEduSeqNumContext.WRE44, @"^[a-zA-Z0-9!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ]*$", RegexOptions.IgnoreCase));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000039", Severity = ProcessMessageSeverity.Error,
                            Description = @"Self education expenses - Explanation of ""other"" evidence/calculation code used contains invalid text",
                            LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.EducationStandardEvidenceCalculationOther.Description[@contextRef='" + rpEduSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000039"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE44", Value = rpEduSeqNumContext.WRE44 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000039
            
                    #region VR.ATO.WRE.000063
            
                    /*  VR.ATO.WRE.000063
                    Self education expenses - Category of expense is present and Self education expenses - Standard evidence/calculation information code is not populated
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{EduSeqNum})
                    IF ([wre41] <> NULLORBLANK AND [wre43] = NULLORBLANK)
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (^WRE41 <> BLANK AND ^WRE43 = BLANK)
            
                    Data Elements:
            
                    RP.{EduSeqNum}:^WRE43 = tns:IncomeTax.Deduction.EducationStandardEvidenceCalculation.Code
            
                    RP.{EduSeqNum}:^WRE41 = tns:IncomeTax.Deduction.EducationCategory.Code
                    */
                    assertion = (string.IsNullOrWhiteSpace(rpEduSeqNumContext.WRE41) != true && string.IsNullOrWhiteSpace(rpEduSeqNumContext.WRE43) == true);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000063", Severity = ProcessMessageSeverity.Error,
                            Description = @"Self education expenses - Standard evidence/calculation information code is required",
                            LongDescription = @"When 'Self education expenses - Category of expense' is set, the 'Self education expenses - Standard evidence/calculation information code' must be provided",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.EducationStandardEvidenceCalculation.Code[@contextRef='" + rpEduSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000063"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE41", Value = rpEduSeqNumContext.WRE41 });
            
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE43", Value = rpEduSeqNumContext.WRE43 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000063
            
                    #region VR.ATO.WRE.000065
            
                    /*  VR.ATO.WRE.000065
                    A Schedule of Work Related Expenses is attached and Self education expenses - Standard evidence/calculation information code is set to either "Other evidence" or "Other Calculation" and Self education expenses - Explanation of "other" evidence/calculation code used is not present on the schedule
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{EduSeqNum}) 
                    IF ([wre43] = SET("Other evidence", "Other calculation") AND [wre44] = NULLORBLANK)
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (InSet(^WRE43, '"Other evidence", "Other calculation"') AND ^WRE44 = BLANK)
            
                    Data Elements:
            
                    RP.{EduSeqNum}:^WRE44 = tns:IncomeTax.Deduction.EducationStandardEvidenceCalculationOther.Description
            
                    RP.{EduSeqNum}:^WRE43 = tns:IncomeTax.Deduction.EducationStandardEvidenceCalculation.Code
                    */
                    assertion = (IsMatch(rpEduSeqNumContext.WRE43, @"^(Other evidence|Other calculation)$") && string.IsNullOrWhiteSpace(rpEduSeqNumContext.WRE44) == true);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000065", Severity = ProcessMessageSeverity.Error,
                            Description = @"Self education expenses - Explanation of ""other"" evidence/calculation code used is required",
                            LongDescription = @"When 'Self education expenses - Standard evidence/calculation information code' is set to either ""Other evidence"" or ""Other Calculation"", the 'Self education expenses - Explanation of ""other"" evidence/calculation code used' must be provided",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.EducationStandardEvidenceCalculationOther.Description[@contextRef='" + rpEduSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000065"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE43", Value = rpEduSeqNumContext.WRE43 });
            
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE44", Value = rpEduSeqNumContext.WRE44 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000065
            
                    #region VR.ATO.WRE.000087
            
                    /*  VR.ATO.WRE.000087
                    When 'Self education expenses - Category of expense' of "Other" is selected, then 'Self education expenses - Details of "other" category used' must be provided
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{EduSeqNum})
                    IF [wre41] = "Other" AND [wre42] = NULLORBLANK
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    ^WRE41 = 'Other' AND ^WRE42 = BLANK
            
                    Data Elements:
            
                    RP.{EduSeqNum}:^WRE42 = tns:IncomeTax.Deduction.EducationCategoryOther.Description
            
                    RP.{EduSeqNum}:^WRE41 = tns:IncomeTax.Deduction.EducationCategory.Code
                    */
                    assertion = (rpEduSeqNumContext.WRE41 == @"Other" && string.IsNullOrWhiteSpace(rpEduSeqNumContext.WRE42) == true);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000087", Severity = ProcessMessageSeverity.Error,
                            Description = @"'Self education expenses - Details of ""other"" category used' must be provided",
                            LongDescription = @"When 'Self education expenses - Category of expense' of ""Other"" is selected, then 'Self education expenses - Details of ""other"" category used' must be provided",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.EducationCategoryOther.Description[@contextRef='" + rpEduSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000087"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE41", Value = rpEduSeqNumContext.WRE41 });
            
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE42", Value = rpEduSeqNumContext.WRE42 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000087
                    }
                }
        
                #endregion // Foreach loop

            #region Repeating RPOTHWRSeqNumContext
            if (report.RPOTHWRSeqNumContextCollection != null)
            {
                int itemIndexContext2 = 0;
                foreach (WRE2017.RPOTHWRSeqNumContext rpothwrSeqNumContext in report.RPOTHWRSeqNumContextCollection)
                {
                    itemIndexContext2++;
            
                    #region VR.ATO.WRE.000022
            
                    /*  VR.ATO.WRE.000022
                    Other work expenses - Details of "other" category used has a maximum length of 40
    
                    Legacy Rule Format:
                    IF (LENGTH([wre51])) > 40
                         RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (Length(^WRE51)) > 40
            
                    Data Elements:
            
                    RP.{OTHWRSeqNum}:^WRE51 = tns:IncomeTax.Deduction.WorkRelatedCategoryOther.Description
                    */
                    assertion = (Length(rpothwrSeqNumContext.WRE51) > 40);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000022", Severity = ProcessMessageSeverity.Error,
                            Description = @"Other work expenses - Details of ""other"" category used must not exceed 40 characters",
                            LongDescription = @"For Other work expenses - Details of ""other"" category used, the maximum allowable characters for this form is 40",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.WorkRelatedCategoryOther.Description[@contextRef='" + rpothwrSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000022"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE51", Value = rpothwrSeqNumContext.WRE51 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000022
            
                    #region VR.ATO.WRE.000023
            
                    /*  VR.ATO.WRE.000023
                    Other work expenses - business % has a maximum length of 3
    
                    Legacy Rule Format:
                    IF (LENGTH([wre52])) > 3
                         RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (Length(^WRE52)) > 3
            
                    Data Elements:
            
                    RP.{OTHWRSeqNum}:^WRE52 = tns:IncomeTax.Deduction.WorkRelatedBusinessUseClaimedOther.Percent
                    */
                    assertion = (Length(rpothwrSeqNumContext.WRE52.GetValueOrDefault()) > 3);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000023", Severity = ProcessMessageSeverity.Error,
                            Description = @"Other work expenses - business % must not exceed 3 characters",
                            LongDescription = @"For Other work expenses - business %, the maximum allowable characters for this form is 3",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.WorkRelatedBusinessUseClaimedOther.Percent[@contextRef='" + rpothwrSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000023"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE52", Value = rpothwrSeqNumContext.WRE52.GetValueOrDefault().ToString() });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000023
            
                    #region VR.ATO.WRE.000024
            
                    /*  VR.ATO.WRE.000024
                    Other work expenses - Details of "other" evidence/calculation code used has a maximum length of 240
    
                    Legacy Rule Format:
                    IF (LENGTH([wre54])) > 240
                         RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (Length(^WRE54)) > 240
            
                    Data Elements:
            
                    RP.{OTHWRSeqNum}:^WRE54 = tns:IncomeTax.Deduction.WorkRelatedStandardEvidenceCalculationOther.Description
                    */
                    assertion = (Length(rpothwrSeqNumContext.WRE54) > 240);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000024", Severity = ProcessMessageSeverity.Error,
                            Description = @"Other work expenses - Details of ""other"" evidence/calculation code used must not exceed 240 characters",
                            LongDescription = @"For Other work expenses - Details of ""other"" evidence/calculation code used, the maximum allowable characters for this form is 240",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.WorkRelatedStandardEvidenceCalculationOther.Description[@contextRef='" + rpothwrSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000024"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE54", Value = rpothwrSeqNumContext.WRE54 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000024
            
                    #region VR.ATO.WRE.000025
            
                    /*  VR.ATO.WRE.000025
                    Car expenses - Car cost price has a maximum field length of 11
    
                    Legacy Rule Format:
                    IF ([wre55] <> MONETARY(U,11,0))
                         RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (NotMonetary(^WRE55, 'U', 11, 0))
            
                    Data Elements:
            
                    RP.{OTHWRSeqNum}:^WRE55 = tns:IncomeTax.Deduction.WorkRelatedOther.Amount
                    */
                    assertion = NotMonetary(rpothwrSeqNumContext.WRE55, @"U", 11, 0);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000025", Severity = ProcessMessageSeverity.Error,
                            Description = @"Car expenses - Car cost price is not in a valid monetary format",
                            LongDescription = @"Car expenses - Car cost price must be unsigned, not exceed 11 digits and not contain a decimal point or any other characters",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.WorkRelatedOther.Amount[@contextRef='" + rpothwrSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000025"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE55", Value = rpothwrSeqNumContext.WRE55.GetValueOrDefault().ToString() });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000025
            
                    #region VR.ATO.WRE.000041
            
                    /*  VR.ATO.WRE.000041
                    A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
                    Legacy Rule Format:
                    IF ([wre51] <> NULLORBLANK) AND (ANY CHARACTER OF [wre51] <> SET("a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    NotCharacterInSet(^WRE51, '"a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "')
            
                    Data Elements:
            
                    RP.{OTHWRSeqNum}:^WRE51 = tns:IncomeTax.Deduction.WorkRelatedCategoryOther.Description
                    */
                    assertion = !string.IsNullOrWhiteSpace(rpothwrSeqNumContext.WRE51) && !(IsMatch(rpothwrSeqNumContext.WRE51, @"^[a-zA-Z0-9!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ]*$", RegexOptions.IgnoreCase));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000041", Severity = ProcessMessageSeverity.Error,
                            Description = @"Other work expenses - Details of ""other"" category used contains invalid text",
                            LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.WorkRelatedCategoryOther.Description[@contextRef='" + rpothwrSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000041"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE51", Value = rpothwrSeqNumContext.WRE51 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000041
            
                    #region VR.ATO.WRE.000042
            
                    /*  VR.ATO.WRE.000042
                    A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' " , . ? / or a space character.
    
                    Legacy Rule Format:
                    IF ([wre54] <> NULLORBLANK) AND (ANY CHARACTER OF [wre54] <> SET("a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "))
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    NotCharacterInSet(^WRE54, '"a-z","A-Z","0-9","!","@","$","%","&","*","(",")","-","=","[","]",";",":","'",""",",",".","?","/"," "')
            
                    Data Elements:
            
                    RP.{OTHWRSeqNum}:^WRE54 = tns:IncomeTax.Deduction.WorkRelatedStandardEvidenceCalculationOther.Description
                    */
                    assertion = !string.IsNullOrWhiteSpace(rpothwrSeqNumContext.WRE54) && !(IsMatch(rpothwrSeqNumContext.WRE54, @"^[a-zA-Z0-9!@\$%&\*\(\)\-=\[\];:'"",\.\?/ ]*$", RegexOptions.IgnoreCase));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000042", Severity = ProcessMessageSeverity.Error,
                            Description = @"Other work expenses - Details of ""other"" evidence/calculation code used contains invalid text",
                            LongDescription = @"A text character must be one of the following: A to Z a to z 0 to 9 ! @ $ % & * ( ) - = [ ] ; : ' "" , . ? / or a space character",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.WorkRelatedStandardEvidenceCalculationOther.Description[@contextRef='" + rpothwrSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000042"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE54", Value = rpothwrSeqNumContext.WRE54 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000042
            
                    #region VR.ATO.WRE.000068
            
                    /*  VR.ATO.WRE.000068
                    Other work expenses - Category of expense' is set to either Home Telephone or Computer expenses including depreciation but 'Other work expenses - business %'  is not present
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{OTHWRSeqNum}) 
                    IF ([wre50] = SET("Home Telephone", "Computer expenses") AND [wre52] = NULL)
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (InSet(^WRE50, '"Home Telephone", "Computer expenses"') AND ^WRE52 = NULL)
            
                    Data Elements:
            
                    RP.{OTHWRSeqNum}:^WRE52 = tns:IncomeTax.Deduction.WorkRelatedBusinessUseClaimedOther.Percent
            
                    RP.{OTHWRSeqNum}:^WRE50 = tns:IncomeTax.Deduction.WorkRelatedCategoryOther.Code
                    */
                    assertion = (IsMatch(rpothwrSeqNumContext.WRE50, @"^(Home Telephone|Computer expenses)$") && rpothwrSeqNumContext.WRE52 == null);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000068", Severity = ProcessMessageSeverity.Error,
                            Description = @"Other work expenses - Category of expense is required",
                            LongDescription = @"When 'Other work expenses - Category of expense' is set to either ""Home Telephone"" or ""Computer expenses"", the 'Other work expenses - business %' must be provided",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.WorkRelatedBusinessUseClaimedOther.Percent[@contextRef='" + rpothwrSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000068"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE50", Value = rpothwrSeqNumContext.WRE50 });
            
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE52", Value = rpothwrSeqNumContext.WRE52.GetValueOrDefault().ToString() });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000068
            
                    #region VR.ATO.WRE.000070
            
                    /*  VR.ATO.WRE.000070
                    Other work expenses - Category of expense is set to either Seminars, books and journals, Home office running expenses, Home office occupancy expenses, Home Telephone, Computer expenses including depreciation, Tools and equipment, Other depreciation, Other, Newspapers, Mobile Phone, Internet Access, Subscriptions or Printing Postage and Stationery and Other work expenses - Standard evidence/calculation information code does not equal either Invoice receipt, PAYG summary, Diary evidence, Allowance, No Substantiation or Other evidence
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{OTHWRSeqNum}) 
                    IF ([wre50] = SET("Seminars", "Books and journals", "Home office running", "Home office occupancy", "Home Telephone", "Computer expenses", "Tools and equipment", "Other depreciation", "Other", "Newspapers", "Mobile Phone", "Internet Access", "Subscriptions", "Printing Postage and Stationery") AND [wre53] <> SET("Invoice receipt", "PAYG summary", "Diary evidence", "Allowance", "No Substantiation", "Other evidence"))
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (InSet(^WRE50, '"Seminars", "Books and journals", "Home office running", "Home office occupancy", "Home Telephone", "Computer expenses", "Tools and equipment", "Other depreciation", "Other", "Newspapers", "Mobile Phone", "Internet Access", "Subscriptions", "Printing Postage and Stationery"') AND NotInSet(^WRE53, '"Invoice receipt", "PAYG summary", "Diary evidence", "Allowance", "No Substantiation", "Other evidence"'))
            
                    Data Elements:
            
                    RP.{OTHWRSeqNum}:^WRE53 = tns:IncomeTax.Deduction.WorkRelatedStandardEvidenceCalculationOther.Code
            
                    RP.{OTHWRSeqNum}:^WRE50 = tns:IncomeTax.Deduction.WorkRelatedCategoryOther.Code
                    */
                    assertion = (IsMatch(rpothwrSeqNumContext.WRE50, @"^(Seminars|Books and journals|Home office running|Home office occupancy|Home Telephone|Computer expenses|Tools and equipment|Other depreciation|Other|Newspapers|Mobile Phone|Internet Access|Subscriptions|Printing Postage and Stationery)$") && !(IsMatch(rpothwrSeqNumContext.WRE53, @"^(Invoice receipt|PAYG summary|Diary evidence|Allowance|No Substantiation|Other evidence)$",RegexOptions.IgnoreCase)));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000070", Severity = ProcessMessageSeverity.Error,
                            Description = @"Other work expenses - Standard evidence/calculation information code is invalid",
                            LongDescription = @"When 'Other work expenses - Category of expense' is set to either ""Seminars"", ""Books and journals"", ""Home office running expenses"", ""Home office occupancy expenses"", ""Home Telephone"", ""Computer expenses including depreciation"", ""Tools and equipment"", ""Other depreciation"", ""Other"", ""Newspapers"", ""Mobile Phone"", ""Internet Access"", ""Subscriptions"" or ""Printing Postage and Stationery"", the associated valid codes for 'Other work expenses - Standard evidence/calculation information code' are; ""Invoice receipt"", ""PAYG summary"", ""Diary evidence"", ""Allowance"", ""No Substantiation"" or ""Other evidence""",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.WorkRelatedStandardEvidenceCalculationOther.Code[@contextRef='" + rpothwrSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000070"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE50", Value = rpothwrSeqNumContext.WRE50 });
            
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE53", Value = rpothwrSeqNumContext.WRE53 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000070
            
                    #region VR.ATO.WRE.000071
            
                    /*  VR.ATO.WRE.000071
                    A Schedule of Work Related Expenses is attached and other work expenses information code is 'O', 'T' and Other work expenses - Details of "other" evidence/calculation code used is not present
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{OTHWRSeqNum})
                    IF ([wre53] = SET("Other evidence", "Other calculation") AND [wre54] = NULLORBLANK)
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    (InSet(^WRE53, '"Other evidence", "Other calculation"') AND ^WRE54 = BLANK)
            
                    Data Elements:
            
                    RP.{OTHWRSeqNum}:^WRE54 = tns:IncomeTax.Deduction.WorkRelatedStandardEvidenceCalculationOther.Description
            
                    RP.{OTHWRSeqNum}:^WRE53 = tns:IncomeTax.Deduction.WorkRelatedStandardEvidenceCalculationOther.Code
                    */
                    assertion = (IsMatch(rpothwrSeqNumContext.WRE53, @"^(Other evidence|Other calculation)$") && string.IsNullOrWhiteSpace(rpothwrSeqNumContext.WRE54) == true);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000071", Severity = ProcessMessageSeverity.Error,
                            Description = @"Other work expenses - Details of ""other"" evidence/calculation code used is required",
                            LongDescription = @"When 'Other work expenses - Standard evidence/calculation information code' is set to either ""Other evidence"" or ""Other Calculation"", the 'Other work expenses - Details of ""other"" evidence/calculation code used' must be provided",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.WorkRelatedStandardEvidenceCalculationOther.Description[@contextRef='" + rpothwrSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000071"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE53", Value = rpothwrSeqNumContext.WRE53 });
            
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE54", Value = rpothwrSeqNumContext.WRE54 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000071
            
                    #region VR.ATO.WRE.000084
            
                    /*  VR.ATO.WRE.000084
                    Numeric field, values nnn where n is a digit 0 to 9 only to be used.
    
                    Legacy Rule Format:
                    IF ([wre52] <> NULL) AND (ANY CHARACTER OF [wre52] <> SET(0-9))
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    NotCharacterInSet(^WRE52, '0-9')
            
                    Data Elements:
            
                    RP.{OTHWRSeqNum}:^WRE52 = tns:IncomeTax.Deduction.WorkRelatedBusinessUseClaimedOther.Percent
                    */
                    assertion = !(IsMatch(rpothwrSeqNumContext.WRE52.GetValueOrDefault().ToString(), @"^[0-9]*$",RegexOptions.IgnoreCase));
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000084", Severity = ProcessMessageSeverity.Error,
                            Description = @"'Other work expenses - business %' must be numeric",
                            LongDescription = @"'Other work expenses - business %' must be a numeric field, values nnn where n is a digit 0 to 9 only to be used",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.WorkRelatedBusinessUseClaimedOther.Percent[@contextRef='" + rpothwrSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000084"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE52", Value = rpothwrSeqNumContext.WRE52.GetValueOrDefault().ToString() });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000084
            
                    #region VR.ATO.WRE.000088
            
                    /*  VR.ATO.WRE.000088
                    When 'Other work expenses - Category of expense' of "Other" is selected, then 'Other work expenses - Details of "other" category used' must be provided
    
                    Legacy Rule Format:
                    WHERE IN CONTEXT(RP.{OTHWRSeqNum})
                    IF [wre50] = "Other" AND [wre51] = NULLORBLANK
                       RETURN VALIDATION MESSAGE
                    ENDIF
        
                    Technical Business Rule Format:
                    ^WRE50 = 'Other' AND ^WRE51 = BLANK
            
                    Data Elements:
            
                    RP.{OTHWRSeqNum}:^WRE51 = tns:IncomeTax.Deduction.WorkRelatedCategoryOther.Description
            
                    RP.{OTHWRSeqNum}:^WRE50 = tns:IncomeTax.Deduction.WorkRelatedCategoryOther.Code
                    */
                    assertion = (rpothwrSeqNumContext.WRE50 == @"Other" && string.IsNullOrWhiteSpace(rpothwrSeqNumContext.WRE51) == true);
                    if (assertion)
                    {
                        processMessage = new ProcessMessageDocument()
                        {
                            Code = "CMN.ATO.WRE.000088", Severity = ProcessMessageSeverity.Error,
                            Description = @"'Other work expenses - Details of ""other"" category used' must be provided",
                            LongDescription = @"When 'Other work expenses - Category of expense' of ""Other"" is selected, then 'Other work expenses - Details of ""other"" category used' must be provided",
                            Location = "/xbrli:xbrl/tns:IncomeTax.Deduction.WorkRelatedCategoryOther.Description[@contextRef='" + rpothwrSeqNumContext.Id + "']",
                            Parameters = new ProcessMessageParameters() { new ProcessMessageParameter() {Name = "RuleIdentifier", Value = "VR.ATO.WRE.000088"} },
                        };
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE50", Value = rpothwrSeqNumContext.WRE50 });
            
                        processMessage.Parameters.Add(new ProcessMessageParameter
                            { Name = "WRE51", Value = rpothwrSeqNumContext.WRE51 });
            
                        response.Add(processMessage);
                    }
                    #endregion // VR.ATO.WRE.000088
                    }
                }
        
                #endregion // Foreach loop

            foreach (ProcessMessageDocument currentProcessMessage in response)
            {
                if (currentProcessMessage.Parameters != null)
                {
                    foreach (ProcessMessageParameter currentParameter in currentProcessMessage.Parameters)
                    {
                        if (string.IsNullOrEmpty(currentParameter.Name))
                        {
                            currentParameter.Name = _emptyParameterValue;
                        }

                        if (currentParameter.Name.Length > _maxParameterNameLength)
                        {
                            currentParameter.Name = currentParameter.Name.Substring(0, _maxParameterNameLength - 1);
                        }

                        if (string.IsNullOrEmpty(currentParameter.Value))
                        {
                            currentParameter.Value = _emptyParameterValue;
                        }

                        if (currentParameter.Value.Length > _maxParameterValueLength)
                        {
                            currentParameter.Value = currentParameter.Value.Substring(0, _maxParameterValueLength - 1);
                        }
                    }
                }
            }

            return response;
        }


    }
} 
